// CSVDialog.cpp : implementation file
//

#include "stdafx.h"
#include "RomLister.h"
#include "CSVDialog.h"
#include ".\csvdialog.h"
#include "xmltype.h"
#include "CSVHeaderDlg.h"

// CCSVDialog dialog

IMPLEMENT_DYNAMIC(CCSVDialog, CDialog)
CCSVDialog::CCSVDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CCSVDialog::IDD, pParent)
{
}

CCSVDialog::~CCSVDialog()
{
}

void CCSVDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CSVDELIM, m_CSVDlgDelim);

	m_CSVDlgDelim.SetWindowText(m_delim);
	((CButton*)GetDlgItem(IDC_CSVADDHEADERS))->SetCheck(1);
	enableOptions();
}


BEGIN_MESSAGE_MAP(CCSVDialog, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_CSVTOGGLEALL, OnBnClickedCsvtoggleall)
END_MESSAGE_MAP()


// CCSVDialog message handlers

void CCSVDialog::OnBnClickedOk()
{
	extern int g_xmlType;
	m_cmdLine = "";
	xmlType xmlData;
	CCSVHeaderDlg dlg;
	
	// romname and description
	if ( ((CButton*)GetDlgItem(IDC_CSVDESCRIPTION))->GetCheck() )
	{
		m_columnHeader = "Description,";
		m_cmdLine +=xmlData.description[g_xmlType]+",";
	}
	if ( ((CButton*)GetDlgItem(IDC_CSVROMNAME))->GetCheck() )
	{
		m_cmdLine +=xmlData.ROMStart[g_xmlType]+",";
		m_columnHeader +="ROM Name,";
	}
	if ( ((CButton*)GetDlgItem(IDC_CSVCLONEOF))->GetCheck() )
	{
		m_cmdLine +="cloneof=,";
		m_columnHeader +="cloneof,";
	}
	if ( ((CButton*)GetDlgItem(IDC_CSVDRIVER))->GetCheck() )
	{
		m_cmdLine +="sourcefile=,";
		m_columnHeader +="driver,";
	}



	// year and manufacturer
	if ( (g_xmlType == MAME) || (g_xmlType == merged) )
	{
		if ( ((CButton*)GetDlgItem(IDC_CSVYEAR))->GetCheck() )
		{
			m_cmdLine +="<year>,";
			m_columnHeader +="Year,";
		}
		if ( ((CButton*)GetDlgItem(IDC_CSVMANUFACTURER))->GetCheck() )
		{
			m_cmdLine +=xmlData.manufacturer[g_xmlType]+","; // "<manufacturer>,";
			m_columnHeader +="Manufacturer,";
		}
	}

		if ( ((CButton*)GetDlgItem(IDC_CSVNUMBUTTONS))->GetCheck() )
		{
			m_cmdLine +="buttons=,";
			m_columnHeader +="Buttons,";
		}

		// buttons and controls
//	if  (g_xmlType == MAME)
//	{
		if ( ((CButton*)GetDlgItem(IDC_CSVCONTROLS))->GetCheck() )
		{
			m_cmdLine +="control_type=,";
			m_columnHeader +="Controls,";
		}
//	}
//	else // controls or merged
//	{
//		if ( ((CButton*)GetDlgItem(IDC_CSVNUMBUTTONS))->GetCheck() )
//			m_cmdLine +="numButtons=,";
//		if ( ((CButton*)GetDlgItem(IDC_CSVCONTROLS))->GetCheck() )
//			m_cmdLine +="control_name=,";
//	}

	// alas.  CSV only pulls stuff out of whatever is in quotes.  cocktail is the keyword inside of quotes.
		if ( ((CButton*)GetDlgItem(IDC_CSVCOCKTAIL))->GetCheck() )
		{
			m_cmdLine +="cocktail=,";
			m_columnHeader +="Cocktail Support,";
		}
	
	// video type and orientation
	if ( (g_xmlType == MAME)  || (g_xmlType == merged) )
	{
		if ( ((CButton*)GetDlgItem(IDC_CSVVIDWIDTH))->GetCheck() )
		{
			m_cmdLine +="width=,";
			m_columnHeader +="Screen Width,";
		}
		if ( ((CButton*)GetDlgItem(IDC_CSVVIDHEIGHT))->GetCheck() )
		{
			m_cmdLine +="height=,";
			m_columnHeader +="Screen Height,";
		}
		if ( ((CButton*)GetDlgItem(IDC_CSVORIENTATION))->GetCheck() )
		{
			m_cmdLine +="rotate=,";
			m_columnHeader +="Rotate,";
		}
		if ( ((CButton*)GetDlgItem(IDC_CSVVIDTYPE))->GetCheck() )
		{
			m_cmdLine +="%<display.type,";
			m_columnHeader +="Display Type,";
		}
		if ( ((CButton*)GetDlgItem(IDC_CSVREFRESHRATE))->GetCheck() )
		{
			m_cmdLine +="refresh=,";
			m_columnHeader +="Refresh Rate,";
		}


		if ( ((CButton*)GetDlgItem(IDC_CSVEMUSTATUS))->GetCheck() )
		{
			m_cmdLine +="emulation=,";
			m_columnHeader +="Emulation Status,";
		}
		
		if ( ((CButton*)GetDlgItem(IDC_CSVCHD))->GetCheck() )
		{
			m_cmdLine +="disk_name=,";
			m_columnHeader +="CHD name,";
		}

		
	}

	// misc from controls
	if ( (g_xmlType == controls)  || (g_xmlType == merged) )
	{
		if ( ((CButton*)GetDlgItem(IDC_CSVCATEGORY))->GetCheck() )
		{
			m_cmdLine +="<category>,";
			m_columnHeader +="Category,";
		}
		if ( ((CButton*)GetDlgItem(IDC_CSVCNTRLSXML))->GetCheck() )
		{
			m_cmdLine +="'<controls_info>',";
			m_columnHeader +="controlsXML_info,";
		}
		if ( ((CButton*)GetDlgItem(IDC_CSVTILT))->GetCheck() )
		{
			m_cmdLine +="tilt=,";
			m_columnHeader +="Tilt,";
		}
		if ( ((CButton*)GetDlgItem(IDC_CSVALTERNATE))->GetCheck() )
		{
			m_cmdLine +="alternating=,";
			m_columnHeader +="Alternating,";
		}
		if ( ((CButton*)GetDlgItem(IDC_CSVNUMPLAYERS))->GetCheck() )
		{
			m_cmdLine +="numPlayers=,";
			m_columnHeader +="Number of Players,";
		}
		if ( ((CButton*)GetDlgItem(IDC_CSVUSESSERVICE))->GetCheck() )
		{
			m_cmdLine +="usesService=,";
			m_columnHeader +="Services,";
		}
		if ( ((CButton*)GetDlgItem(IDC_CSVMIRRORED))->GetCheck() )
		{
			m_cmdLine +="mirrored=,";
			m_columnHeader +="Mirrored,";
		}

		if ( ((CButton*)GetDlgItem(IDC_CSVVERADDED))->GetCheck() )
		{
			m_cmdLine +="<verAdded>,";
			m_columnHeader +="Version Added,";
		}
	}



//	m_columnHeader.TrimRight(",");
//	m_cmdLine.TrimRight(",");

	dlg.m_headersIn = m_columnHeader;
	dlg.m_hiddenDataIn = m_cmdLine;
	dlg.DoModal();
	m_columnHeader = dlg.m_headersOut;
	m_cmdLine = dlg.m_hiddenDataOut;


	m_CSVDlgDelim.GetWindowText(m_delim);
	m_columnHeader.Replace(",",m_delim);

	// if column headers not requested, blank 'em
	if ( !((CButton*)GetDlgItem(IDC_CSVADDHEADERS))->GetCheck() )
		m_columnHeader="";

	// append each checkbox criteria to the cmdline
	OnOK();
}
void CCSVDialog::enableOptions()
{
	extern int g_xmlType; // merged file? (it'd be best if we knew it was merged with catver and stuff too...)

	if ( g_xmlType == controls)	// controls only?  who the hell does that?
	{
		((CButton*)GetDlgItem(IDC_CSVYEAR))->EnableWindow(0);
		((CButton*)GetDlgItem(IDC_CSVMANUFACTURER))->EnableWindow(0);
		((CButton*)GetDlgItem(IDC_CSVORIENTATION))->EnableWindow(0);
		((CButton*)GetDlgItem(IDC_CSVVIDTYPE))->EnableWindow(0);
		((CButton*)GetDlgItem(IDC_CSVVIDHEIGHT))->EnableWindow(0);
		((CButton*)GetDlgItem(IDC_CSVVIDWIDTH))->EnableWindow(0);
		((CButton*)GetDlgItem(IDC_CSVEMUSTATUS))->EnableWindow(0);
	}

	else if ( g_xmlType == MAME ) // MAME
	{
		((CButton*)GetDlgItem(IDC_CSVCOCKTAIL))->EnableWindow(0);
		((CButton*)GetDlgItem(IDC_CSVTILT))->EnableWindow(0);
		((CButton*)GetDlgItem(IDC_CSVNUMPLAYERS))->EnableWindow(0);
		((CButton*)GetDlgItem(IDC_CSVALTERNATE))->EnableWindow(0);
		((CButton*)GetDlgItem(IDC_CSVMIRRORED))->EnableWindow(0);
		((CButton*)GetDlgItem(IDC_CSVUSESSERVICE))->EnableWindow(0);
		((CButton*)GetDlgItem(IDC_CSVCATEGORY))->EnableWindow(0);
		((CButton*)GetDlgItem(IDC_CSVVERADDED))->EnableWindow(0);
	}


}


void CCSVDialog::OnBnClickedCsvtoggleall()
{
	for (int i=IDC_CSVYEAR; i<=IDC_CSVVIDHEIGHT; i++)
		((CButton*)GetDlgItem(i))->SetCheck(m_onoff);
	m_onoff = !(m_onoff);
}
