// ErrorMessage.h: interface for the CErrorMessage class.
//
// CErrorMessage - Simple object for throwing an exception and
//                 diplaying a message to the user.
//
//
// Usage:
//
//		To specify the message to be displayed to the user, set
//      member object m_sMsg to the message you wish to display.
//
//      The message can be diplayed by calling the Report() function, 
//      or the m_sMsg member can be used in an explicit message box call.
//
//      The flag fDontReport can be used to suppress the displaying of a message.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ERRORMESSAGE_H__ECD5C5A2_84F6_482E_8A1B_B288CC03C746__INCLUDED_)
#define AFX_ERRORMESSAGE_H__ECD5C5A2_84F6_482E_8A1B_B288CC03C746__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
//
// Default Values
//
#define MSG_DEFAULT "No Error Description."
#define ICON_DEFAULT MB_ICONERROR

//******************************************************************
// CErrorMessage
//
//
//
//******************************************************************
class CErrorMessage  
{
public:
	CErrorMessage();
	CErrorMessage(const char* sMsg, long Icon=ICON_DEFAULT, BOOL fDontReport=FALSE);
	virtual ~CErrorMessage();
	virtual int Report(void);			// Report Error in a Message Box

	BOOL m_fDontReport;					// Flag to suppress error reporting
	long m_MsgIcon;						// Type of Icon to diplay in the Message box
	CString m_sMsg;						// Error message string
	
};

#endif // !defined(AFX_ERRORMESSAGE_H__ECD5C5A2_84F6_482E_8A1B_B288CC03C746__INCLUDED_)
