#include "StdAfx.h"
#include ".\filestuff.h"
#include "xmlType.h"
#include "rl.h"
#include "stringx.h"

CFileStuff::CFileStuff(void)
{
}

CFileStuff::~CFileStuff(void)
{
}

// return a copy of the xml header
// scan until we find <game
// 
void CFileStuff::getXMLHeader(FILE* pinputFile, CString &xmlHeader)
{
	xmlType header;
	extern int g_xmlType;
	CStringEx tmp;
	CString buildNum;
	bool buildFound = false;

	bool output=true;
	char buffer[200];
	int count=0;
	xmlType xmlData;

	fseek(pinputFile, 0, SEEK_SET);	// start at beginning of file

	while (output) 
	{
		if (fgets(buffer,sizeof(buffer),pinputFile) != NULL)
			{	
				tmp=buffer;
				count++;

				if (count >1000) //ifwe haven't seenit yet, we're not going to.
				{
					xmlHeader="";
					break;
				}

				// look for the end of the header marker.  for different xml files, this is of course different. ugh.
					 //MAME                             hyperspin
				for (int i=0; i<xmltypes; i++)
				{
					if ( tmp.FindNoCase(xmlData.ROMStart[i]) != -1) // end of header?
					{
						output=false;
						break;
					}
				}
/*
				{
					output=false;
					xmlHeader+=tmp;
					// aug 4 2009 - the xml header is missing the <mame build> top tag.  This causes advancemame (and likely others) to choke
					// ok, see if we can find the mame build line here
					// check no more than 25 lines
					for (int i=0; i<25; i++)
					{
						fgets(buffer,sizeof(buffer),pinputFile);
						tmp=buffer;
						if (tmp.Find("<mame build") > -1)
						{
							buildNum=tmp;
							buildFound = true;
							break;
						}
					}

					if (!buildFound)
						buildNum = "<mame>\r\n";	// generate a generic xml tag top
				}
*/
				if (output)
					xmlHeader+=tmp;
			}
		else
		{
			xmlHeader = "";	// invalid/EOF reached
			break;
		}
	}
	// rewind the file a bit so that the next thing we grab are rom descriptors
	fseek(pinputFile,-150L,SEEK_CUR);
	

}

// figure out what the xml footer should be for the provided xml file
// we could either jump to the end of the file and look for it, or figure out what the open tag is based off the header
// let's use the header for now.
CString CFileStuff::getXMLFooter(CString xmlHeader)
{
	CString footer;
	int i;
	// look for a line that starts with "<" but is not "<?" or "<!"
	// could also look for tabs (first one w/o tabs) but that might not be safe
	for (i=0; i<500; i++)
	{
		AfxExtractSubString(footer, xmlHeader, i, '\n');
		footer.Trim();
		if (footer.IsEmpty()) 
			continue;
		if ( (footer.Find("<?") ==-1) && (footer.Find("<!") ==-1) && (footer.Find("]>") ==-1) )
			break;
	}
	
	if (i < 500)
	{
		AfxExtractSubString(footer, footer, 0, ' ');	// for <mame build xyz..." to trim it down to just </mame>
		footer.Insert(1,"/");
		if (footer.Right(1) != ">")
			footer.Append(">");
	}
	else
		footer = "</>";
	return footer;
}
// copy the main header portion from the input xml file to the output file
// returns, although the global variable is also set...
//    -1=XML header failed to be read/located
//     0=MAME header
//     1=controls.dat xml header 
//	   2=merged list (best of all!)	
int CFileStuff::getXMLType(FILE* pinputFile)
{
	extern int g_xmlType;
	xmlType header;
	CString tmp;

	getXMLHeader(pinputFile, tmp);

	if ( tmp.Find("mame (game+)") > -1 )  // MAME xml list?
		g_xmlType = MAME;
	if ( tmp.Find("mame (machine+)") > -1 )  // MAME 162 xml list?
		g_xmlType = MAME162;
	if ( tmp.Find("DOCTYPE dat") > -1 )  // controls.xml list?
		g_xmlType = controls;
	if ( tmp.Find("generated by ROMLister") > -1 )  // merged list?
		g_xmlType = merged;
	if ( tmp.Find("DOCTYPE softwarelist") > -1 )  // MESS xml list?
		g_xmlType = MESS;
	return g_xmlType;
}

// returns false when EOF reached
// returns file position of the start of the rom, -1 for end of file.
// if a file position is inputted, we seek to that starting point before starting to search for our keyword
int CFileStuff::getROMDesc(FILE* pinputFile, CString &romDesc, CString keyword, int filePos)
{
#define bufSize 2048
	CRl m_RL;
	//	bool eof = false;	// reached end of file?
	CStringEx tmp;
	CString endDesc;
	char buffer[bufSize];
	bool flag=false;
	romDesc = "";
	CString notDevice = "isdevice=\"yes\"";
	extern int g_xmlType;
	xmlType xmlData;

	if (filePos != -1)
		fseek(pinputFile, filePos, SEEK_SET);
	
	endDesc = xmlData.ROMEnd[g_xmlType];	//"</game>";

	while (1)
	{
	if (fgets(buffer,sizeof(buffer),pinputFile) != NULL)
			{	
				tmp=buffer;
				if ( (tmp.FindNoCase(keyword) > -1 ) && (tmp.Find(notDevice) == -1) ) // first line of rom list located? (and not one of these "isDevice=yes" things)
				{
					fgetpos (pinputFile,&m_filePos); // save file pos incase we need it for backing up
					m_filePos -=tmp.GetLength()+1;
					flag = true;
				}	
				if (flag == true) romDesc +=tmp;  // append this line to buffer
				
				if ( (tmp.FindNoCase(endDesc) > -1 ) && (flag==true) )	// found the end?  Maybe switch this to something that reflects different search criteria
					break;
			}
	else
		{
			m_filePos = -1; //eof = true;	// flag EOF
			break;  // exit while loop on read error
		}
	}

	m_RL.xml2txt(romDesc);
	return (int)m_filePos; //!eof;

}

// get PREVIOUS rom description
// returns false when TOF reached - not really used anymore
bool CFileStuff::getPrevROMDesc(FILE* pinputFile, CString &romDesc, CString keyword)
{
	extern int g_xmlType;
	xmlType header;
	// rewind the file to the previous rom descriptor position
	fseek(pinputFile, (long) m_prevFilePos[fIndex]-85, SEEK_SET); // arbitrarily move back a little more.
	// now get the next description
	if (getROMDesc(pinputFile, romDesc, header.ROMStart[g_xmlType]) != -1)
        return true;
	else
		return false;
}

void CFileStuff::resetFile(FILE* pinputFile)
{
	fseek(pinputFile, 0, SEEK_SET);
}

BOOL CFileStuff::UserBrowseOpen(CString *pPath, LPCTSTR Filter, LPCTSTR DefaultExt)
{

	OPENFILENAME	ofn;

	LPTSTR lpPathBuff = pPath->GetBuffer(MAX_PATH);

	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.lpstrFilter = Filter;
	ofn.nFilterIndex = 1;
	ofn.lpstrDefExt = DefaultExt;
	ofn.lpstrFile = lpPathBuff;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrCustomFilter = NULL;
	ofn.lpstrTitle = m_windowTitle;  // window title
	ofn.Flags = OFN_HIDEREADONLY+OFN_EXPLORER;
	


	// display file open/save dialog
	BOOL result;
	result = GetOpenFileName(&ofn);

	pPath->ReleaseBuffer();

	return result;
}

BOOL CFileStuff::UserBrowseSave(CString *pPath, LPCTSTR Filter, LPCTSTR DefaultExt)
{

	OPENFILENAME	ofn;

	LPTSTR lpPathBuff = pPath->GetBuffer(MAX_PATH);

	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.lpstrFilter = Filter;
	ofn.nFilterIndex = 1;
	ofn.lpstrDefExt = DefaultExt;
	ofn.lpstrFile = lpPathBuff;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrCustomFilter = NULL;
	ofn.lpstrTitle = m_windowTitle;  // window title
	ofn.Flags = OFN_HIDEREADONLY+OFN_EXPLORER;
	
	// display file open/save dialog
	BOOL result;
	result = GetSaveFileName(&ofn);

	pPath->ReleaseBuffer();

	return result;
}

// part of user browse folder below
int CALLBACK BrowseCallbackProc(HWND hwnd,
    UINT uMsg,LPARAM lParam,LPARAM lpData)
{
	CString Path;

	// Look for BFFM_INITIALIZED so we know our dialog is available
	if(uMsg == BFFM_INITIALIZED)
    {
		Path = "c:\\"; //regMyReg["SourceDir"];
		SendMessage(hwnd, BFFM_SETSELECTION,
			TRUE, (LPARAM)(LPCTSTR)(Path)); 
    }
    return 0;
}

BOOL CFileStuff::UserBrowseFolder(CString &folderpath, const char* szCaption, HWND hOwner)
{
	BOOL retVal = false;

	// The BROWSEINFO struct tells the shell 
	// how it should display the dialog.
	BROWSEINFO bi;
	memset(&bi, 0, sizeof(bi));

	bi.ulFlags   = BIF_USENEWUI | BIF_VALIDATE;
	bi.hwndOwner = hOwner;
	bi.lpszTitle = szCaption;
	
	// Set the callback function
    bi.lpfn = BrowseCallbackProc;

	// must call this if using BIF_USENEWUI
	::OleInitialize(NULL);

	// Show the dialog and get the itemIDList for the selected folder.
	LPITEMIDLIST pIDL = ::SHBrowseForFolder(&bi);

	if(pIDL != NULL)
	{
		// Create a buffer to store the path, then get the path.
		char buffer[_MAX_PATH] = {'\0'};
		if(::SHGetPathFromIDList(pIDL, buffer) != 0)
		{
			// Set the string value.
			folderpath = buffer;
			retVal = true;
		}		

		// free the item id list
		CoTaskMemFree(pIDL);
	}

	::OleUninitialize();

	return retVal;
}

	

// returns false when EOF reached
bool CFileStuff::loadFile(FILE* pinputFile, CString &fileData)
{
	bool eof = false;	// reached end of file?
	char buffer[200];
	bool flag=false;
	fileData = "";
	CString tmp;

	while (1)
	{
	if (fgets(buffer,sizeof(buffer),pinputFile) != NULL)
			{	
				tmp=buffer;
				fileData +=tmp;
			}
	else
		{
			eof = true;	// flag EOF
			break;  // exit while loop on read error
		}
	}
	return !eof;
}