// ROMListerSettingsDlg.cpp : implementation file
// and mondoMerge tool

#include "stdafx.h"
#include "RomLister.h"
#include "ROMListerSettingsDlg.h"
#include ".\romlistersettingsdlg.h"
#include "filestuff.h"
#include "registry.h"
#include "rl.h"
#include "progressDlg.h"
#include "SADirRead.h"
#include "XMLType.h"
#include "RomListerDlg.h"

// for mala list converter
#include "malaListDef.h"

// CROMListerSettingsDlg dialog

IMPLEMENT_DYNAMIC(CROMListerSettingsDlg, CDialog)
CROMListerSettingsDlg::CROMListerSettingsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CROMListerSettingsDlg::IDD, pParent)
{
}

CROMListerSettingsDlg::~CROMListerSettingsDlg()
{
}

void CROMListerSettingsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LISTXMLPATH, m_listXMLPath);
	DDX_Control(pDX, IDC_CONTROLSXMLPATH, m_controlsXMLPath);
	DDX_Control(pDX, IDC_CATVERPATH, m_catVerPath);
	DDX_Control(pDX, IDC_OUTPUT_FILE, m_outputFilename);
	DDX_Control(pDX, IDC_NPLAYERSPATH, m_nplayersPath);
}


BEGIN_MESSAGE_MAP(CROMListerSettingsDlg, CDialog)
	ON_BN_CLICKED(IDC_LISTXMLBROWSE, OnBnClickedListxmlbrowse)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_CONTROLSXMLBROWSE, OnBnClickedControlsxmlbrowse)
	ON_BN_CLICKED(IDC_CATVERBROWSE, OnBnClickedCatverbrowse)
	ON_BN_CLICKED(IDC_MERGEIT, OnBnClickedMergeit)
	ON_BN_CLICKED(IDC_OUTPUTFILEBTN, OnBnClickedOutputfilebtn)
	ON_BN_CLICKED(IDC_ROMSCANBTN, OnBnClickedRomscanbtn)
	ON_BN_CLICKED(IDC_NPLAYERSBROWSE, OnBnClickedNplayersbrowse)
	ON_BN_CLICKED(IDC_LOADLIST, OnBnClickedMala2XML)
	ON_BN_CLICKED(IDC_xml2ini, OnBnClickedxml2ini)
	ON_BN_CLICKED(IDC_ROMDIR2XML, OnBnClickedRomdir2xml)
	ON_BN_CLICKED(IDC_LISTCONVERT, OnBnClickedListconvert)
END_MESSAGE_MAP()


BOOL CROMListerSettingsDlg::OnInitDialog()
{
	extern int g_hideTags;
	CDialog::OnInitDialog();
	// dig out our previously accessed filenames.
	// if it doesn't exist, then pop up the intro message.
	CRegistry regMyReg( NULL );  // No special flags

	// get all filenames from the registry
	if ( regMyReg.Open("Software\\ROMLister",HKEY_CURRENT_USER) ) 
	{
		// get the data
		m_masterFilePath = regMyReg["inputXMLFile"];
		m_sXmlFilePath = regMyReg["listXMLFile"];;		// path+file to MAME's listxml
		m_sCatverFilePath = regMyReg["catverFile"];;	// path+file of catver.ini
		m_controlsFilePath = regMyReg["controlsFile"];	// path+file of controls.xml
		m_nplayersFilePath = regMyReg["nplayersFile"];	// path+file of nplayers.ini

		sscanf(regMyReg["hideSHA1s"],"%d",&m_hideSHA1s);
		sscanf(regMyReg["hideTags"],"%d",&g_hideTags);

		// Close the open key
		regMyReg.Close();

		// jam the values into the window controls
		m_listXMLPath.SetWindowText(m_sXmlFilePath);
		m_catVerPath.SetWindowText(m_sCatverFilePath);
		m_controlsXMLPath.SetWindowText(m_controlsFilePath);
		m_outputFilename.SetWindowText(m_masterFilePath);
		m_nplayersPath.SetWindowText(m_nplayersFilePath);
		if (m_hideSHA1s)
			((CButton*)GetDlgItem(IDC_ROMNAMEHIDE))->SetCheck(1);
		if (g_hideTags)
			((CButton*)GetDlgItem(IDC_HIDETAGS))->SetCheck(1);


	}

	// can't let go until the input path is set.
	if (m_masterFilePath.GetLength() == 0)
		((CButton*)GetDlgItem(IDOK))->EnableWindow(FALSE);

	// if we've got all three inputs, we can merge 'em.
//	if ( (m_controlsFilePath.GetLength() > 0) && (m_sCatverFilePath.GetLength() > 0) && (m_sXmlFilePath.GetLength() > 0) )
//		((CButton*)GetDlgItem(IDC_MERGEIT))->EnableWindow(TRUE);
//	else

	((CButton*)GetDlgItem(IDC_MERGEIT))->EnableWindow(FALSE);
	checkMergeButton();
	
	return TRUE;  
}
// plain ole browse to XML file
void CROMListerSettingsDlg::OnBnClickedOutputfilebtn()
{
	CFileStuff fileStuff;
	LPCTSTR FileFilter = "xml files (*.xml)\0*.xml\0"; //all files (*.*)\0*.*\0";
	LPCTSTR FileExt = "xml";
	fileStuff.m_windowTitle = "Point me to your xml file please...";

	CString oldName = m_masterFilePath;

	if (fileStuff.UserBrowseSave(&m_masterFilePath, FileFilter, FileExt))
	{
		m_outputFilename.SetWindowText(m_masterFilePath);
		((CButton*)GetDlgItem(IDOK))->EnableWindow(TRUE);
		if (oldName !=m_masterFilePath)
		{
			((CButton*)GetDlgItem(IDC_ROMSCANBTN))->EnableWindow(FALSE);
			((CButton*)GetDlgItem(IDC_LISTCONVERT))->EnableWindow(FALSE);
			((CButton*)GetDlgItem(IDC_SETWARN))->ShowWindow(TRUE);
		}
	}
}

void CROMListerSettingsDlg::OnBnClickedListxmlbrowse()
{
	int pos;
	CString arg;
	CString filename;
	CFileStuff fileStuff;
	FILE* inFile;

	LPCTSTR FileFilter = "exe files (*.exe)\0*.exe\0xml files (*.xml)\0*.xml\0"; //all files (*.*)\0*.*\0";
	LPCTSTR FileExt = "exe;xml";
	fileStuff.m_windowTitle = "Point me to MAME or MAME's xml file please...";

	if (fileStuff.UserBrowseOpen(&fileStuff.m_sFilePath, FileFilter, FileExt))
	{
		m_sXmlFilePath = fileStuff.m_sFilePath;
		// we now have a pointer to file.exe or file.xml	
		pos = fileStuff.m_sFilePath.Find(".exe");
		if (pos != -1)	// did we point to mame.exe?
		{
			// break apart the path from the filename, switch to the path and shell out to MAME.
			m_sXmlFilePath = fileStuff.m_sFilePath.Left(fileStuff.m_sFilePath.ReverseFind('\\')+1);
			SetCurrentDirectory(m_sXmlFilePath);  // change to that directory
			AfxMessageBox("I will now attempt to coax MAME.exe to give up the full xml listing.\r\nThis may take awhile, and you'll see a DOS window pop up for a bit.\r\n\r\nDon't Panic.", MB_ICONEXCLAMATION, 0);
			fileStuff.m_sFilePath.Replace(m_sXmlFilePath,"");  // everything leftover is the filename
			filename = fileStuff.m_sFilePath;

			arg = filename+" -listxml >listxml.xml";
			system (arg);
			m_sXmlFilePath += "listxml.xml";

			// now open that file to check on its size to make sure it was generated properly
			// open outputfile
			inFile = fopen(m_sXmlFilePath,"r");
			if (inFile == NULL)
			{
				AfxMessageBox("huh? Can't open the listXML file that we JUST had MAME generate!?", MB_ICONEXCLAMATION, 0);
				return;
			}
			// get the file size...
			CFileStatus filestatus;
			CFile::GetStatus( m_sXmlFilePath, filestatus );
			fclose(inFile);	
			if (filestatus.m_size < (1*1024*1024))	// any data in that file we just created?
			{
				AfxMessageBox("Outfile file is invalid.  Is this really a MAME exe that you pointed me to?", MB_ICONEXCLAMATION, 0);
				return;
			}
		}
		m_listXMLPath.SetWindowText(m_sXmlFilePath);
		theApp.m_fAllListOpen = false;
	}

	// if we've got all three inputs, we can merge 'em.
	if ( (m_controlsFilePath.GetLength() > 0) && (m_sCatverFilePath.GetLength() > 0) && (m_sXmlFilePath.GetLength() > 0) )
		((CButton*)GetDlgItem(IDC_MERGEIT))->EnableWindow(TRUE);

}

void CROMListerSettingsDlg::OnBnClickedControlsxmlbrowse()
{
	CFileStuff fileStuff;
	LPCTSTR FileFilter = "xml files (*.xml)\0*.xml\0"; //all files (*.*)\0*.*\0";
	LPCTSTR FileExt = "xml";
	fileStuff.m_windowTitle = "Point me to controls.xml please...";

	if (fileStuff.UserBrowseOpen(&m_controlsFilePath, FileFilter, FileExt))
		m_controlsXMLPath.SetWindowText(m_controlsFilePath);

	checkMergeButton();
}
void CROMListerSettingsDlg::OnBnClickedCatverbrowse()
{
	CFileStuff fileStuff;
	LPCTSTR FileFilter = "ini files (*.ini)\0*.ini\0"; //all files (*.*)\0*.*\0";
	LPCTSTR FileExt = "ini";
	fileStuff.m_windowTitle = "Point me to catver.ini please...";

	if (fileStuff.UserBrowseOpen(&m_sCatverFilePath, FileFilter, FileExt))
		m_catVerPath.SetWindowText(m_sCatverFilePath);
	
	checkMergeButton();
}
void CROMListerSettingsDlg::OnBnClickedNplayersbrowse()
{
	CFileStuff fileStuff;
	LPCTSTR FileFilter = "ini files (*.ini)\0*.ini\0"; //all files (*.*)\0*.*\0";
	LPCTSTR FileExt = "ini";
	fileStuff.m_windowTitle = "Point me to nplayers.ini please...";

	if (fileStuff.UserBrowseOpen(&m_nplayersFilePath, FileFilter, FileExt))
		m_nplayersPath.SetWindowText(m_nplayersFilePath);
	
	checkMergeButton();
}

void CROMListerSettingsDlg::checkMergeButton()
{

	// if we've got all the inputs, we can finally merge 'em.
	if ( (m_controlsFilePath.GetLength() > 0) && (m_sCatverFilePath.GetLength() > 0) && (m_sXmlFilePath.GetLength() > 0) )
		((CButton*)GetDlgItem(IDC_MERGEIT))->EnableWindow(TRUE);
}


void CROMListerSettingsDlg::OnBnClickedOk()
{
	extern int g_hideTags;
	extern int g_xmlType;
	// save path+filename of input files to registry
	m_outputFilename.GetWindowText(m_masterFilePath);
	CRegistry regMyReg( CREG_CREATE );  // create registry key if it doesn't exist.
	if ( regMyReg.Open("Software\\ROMLister",HKEY_CURRENT_USER) ) 
		{
			// Now set the new values
			regMyReg["inputXMLFile"] = m_masterFilePath;
			regMyReg["listXMLFile"] = m_sXmlFilePath;
			regMyReg["catverFile"] = m_sCatverFilePath;
			regMyReg["controlsFile"] = m_controlsFilePath;
			regMyReg["nplayersFile"] = m_nplayersFilePath;
			if (((CButton*)GetDlgItem(IDC_ROMNAMEHIDE))->GetCheck())
			{
                regMyReg["hideSHA1s"] = "1";
				m_hideSHA1s = 1;
			}
			else
			{
				regMyReg["hideSHA1s"] = "0";
				m_hideSHA1s = 0;
			}
			
			if (((CButton*)GetDlgItem(IDC_HIDETAGS))->GetCheck())
			{
                regMyReg["hideTags"] = "1";
				g_hideTags = 1;
			}
			else
			{
				regMyReg["hideTags"] = "0";
				g_hideTags = 0;
			}			// Close the open key
			regMyReg.Close();
		}
	g_xmlType=-1;
	
	theApp.m_fAllListOpen = false;
	OnOK();
}
// MERGE TOOL is here
void CROMListerSettingsDlg::OnBnClickedMergeit()
{
	extern int g_xmlType;
	xmlType xmlData;
	FILE* inFile;
	FILE* outFile;
	CFileStuff m_file;
	CString romName;
	CString tmp;
	CString logName;
	CString ROMType;
	CString ROMDesc;
	CString controlsDatalc;
	m_xmlHeader = "";
	//CString x = CTime::GetCurrentTime();
//	CString d = CTime::GetDay().
CTime time = CTime::GetCurrentTime();
CString d = time.Format( "%A, %B %d, %Y" );
CString t = CTime::GetCurrentTime().Format("%H:%M");
	int catverAddedPos;
	g_xmlType = -1; 

	CString logData = "ROMLister merge utility log file.  Delete me if you don't care if merge is missing any data.\r\nFile created on:"+d+"@"+t+"\r\n";
	int pos;
	int pos2;
	CFileStuff fileStuff;
	CRl RL;
	bool nPlayers = false;
	bool catver = false;
	bool mame162 = false;


	// one last browse function to save the merged file to.		
	LPCTSTR FileFilter = "xml files (*.xml)\0*.xml\0";
	LPCTSTR FileExt = "xml";
	fileStuff.m_windowTitle = "Save merged file as...";

	if (fileStuff.UserBrowseSave(&m_masterFilePath, FileFilter, FileExt))
	{
		m_outputFilename.SetWindowText(m_masterFilePath);
		((CButton*)GetDlgItem(IDOK))->EnableWindow(TRUE);
	}
	else
		return;	// cancelled


	// open outputfile
	outFile = fopen(m_masterFilePath,"w");
	if (outFile == NULL)
	{
		AfxMessageBox("Error opening output file for write!?", MB_ICONEXCLAMATION, 0);
		return;
	}


	CProgressDlg progDlg;
	progDlg.Init(PROG_MODE_TIMER, 1000, "Merging data, hang on...");

	
	// load catver.ini
	if (m_sCatverFilePath.GetLength() > 0)
	{
		progDlg.UpdateText("Merging data, hang on...","processing catver.ini...");
		// open the file and load all of it.
		inFile = fopen(m_sCatverFilePath,"r");
	
		if (inFile != NULL)
			m_file.loadFile(inFile, m_catverData);
	
		// close input file
		if (inFile != NULL)
		{
			fclose(inFile);	
			catver=true;
		}

		// catver changed from "rom=cat" to "rom = cat"
		// convert the data back
		m_catverData.Replace(" = ","=");
	}

	// load controls.xml

	if (m_controlsFilePath.GetLength() > 0)
	{
		progDlg.UpdateText("Merging data, hang on...","processing controls.xml...");
		// open the file and load all of it.
		inFile = fopen(m_controlsFilePath,"r");
	
		if (inFile != NULL)
			m_file.loadFile(inFile, m_controlsData);
		
		// copy and lowercase this data
		controlsDatalc = m_controlsData;
		controlsDatalc.MakeLower();

		// close input file
		if (inFile != NULL)
			fclose(inFile);	
	}

	// load nplayers.ini
	if (m_nplayersFilePath.GetLength() > 0)
	{
		progDlg.UpdateText("Merging data, hang on...","processing nplayers.ini...");
		// open the file and load all of it.
		inFile = fopen(m_nplayersFilePath,"r");
	
		if (inFile != NULL)
			m_file.loadFile(inFile, m_nplayersData);

		// close input file
		if (inFile != NULL)
		{
			m_nplayersData+="\n"; // add a CR/LF to the end of the data, just in case.
			fclose(inFile);	
			nPlayers = true;
		}
			
	}



	// open the MAME xml file
	inFile = fopen(m_sXmlFilePath,"r");
	if (inFile == NULL)
	{
		AfxMessageBox("Error opening MAME's listxml file for reading!?", MB_ICONEXCLAMATION, 0);
		return;
	}

	progDlg.UpdateText("Merging data, hang on...","processing master xml file...");
	if (g_xmlType == -1)
		m_file.getXMLType(inFile);

	if (g_xmlType == MAME162)
	{
		tmp = "Note: Your input XML file appears to be from MAME 162 or later.\r\nAs a temporary work around to support the new XML formatting, ROMLister will ";
		tmp+= "convert the file back to the formatting used prior to MAME 162.\r\nFuture versions of ROMLister will work with both formats.";
		AfxMessageBox(tmp, MB_ICONEXCLAMATION, 0);
		mame162 = true;
	}


	// grab the xml file header so we can append it to the output
	m_file.getXMLHeader(inFile, m_xmlHeader);
	CString footer = m_file.getXMLFooter(m_xmlHeader);

	if (mame162)
		m_ROMData.Replace("mame (machine+)","mame (game+)");



	// inject a merged signature here
	pos = m_xmlHeader.Find(">");
	m_xmlHeader.Insert(pos+2,"<!-- This file generated by ROMLister -->\n");


	fwrite(m_xmlHeader, sizeof( char ), m_xmlHeader.GetLength(), outFile );


	if (catver)
	{
		catverAddedPos = m_catverData.Find("[VerAdded]");
		if (catverAddedPos == -1)
		{	
			AfxMessageBox("catver.ini doesn't appear to have a [VerAdded] section!?", MB_ICONEXCLAMATION, 0);
			return;
		}
	}


	while (fileStuff.getROMDesc(inFile, m_ROMData, xmlData.ROMStart[g_xmlType]) != -1)  // get everything from <game down to /game>
		{
			// apply xml fixes.
			// sometime around 145, mamedev folks changed "<control type="joy4way"/>" to "<control type="joy" ways="4"/>"
			// put them back the way we're used to, for backwards compatibility.
			// this is maybe not a good idea, but the best we have so far. 
			// 
			m_ROMData.Replace("<control type=\"joy\" ways=\"2\"/>","<control type=\"joy2way\"/>");
			m_ROMData.Replace("<control type=\"joy\" ways=\"4\"/>","<control type=\"joy4way\"/>");
			m_ROMData.Replace("<control type=\"joy\" ways=\"8\"/>","<control type=\"joy8way\"/>");
			m_ROMData.Replace("<control type=\"doublejoy\" ways=\"8\" ways2=\"8\"/>","<control type=\"doublejoy8way\"/>");
			m_ROMData.Replace("<control type=\"joy\" ways=\"3 (half4)\"/>","<control type=\"joy4way\"/>");
			m_ROMData.Replace("<control type=\"joy\" ways=\"5 (half8)\"/>","<control type=\"joy8way\"/>");
			m_ROMData.Replace("<control type=\"doublejoy\" ways=\"2\" ways2=\"2\"/>","<control type=\"doublejoy2way\"/>");
			m_ROMData.Replace("<control type=\"doublejoy\" ways=\"4\" ways2=\"4\"/>","<control type=\"doublejoy4way\"/>"); 
			m_ROMData.Replace("<control type=\"doublejoy\" ways=\"8\" ways2=\"2\"/>","<control type=\"doublejoy8way\"/>");
			m_ROMData.Replace("<control type=\"doublejoy\" ways=\"vertical2\" ways2=\"vertical2\"/>","<control type=\"doublejoy4way\"/>");
			m_ROMData.Replace("<control type=\"joy\" ways=\"1\"/>","<control type=\"joy2way\"/>");
			m_ROMData.Replace("<control type=\"joy\" ways=\"vertical2\"/>","<control type=\"joy2way\"/>");

			// got a ROM description.  see if there's a match in catver and controls
			RL.getROMName(m_ROMData, romName);

			progDlg.UpdateText("Merging data, hang on...","Adding ROM:"+romName);

			logName = romName;
			// catver.ini appears to list all clones too, so no need to look up the parent name.
			
			// look up this rom name in catver.ini
			if (catver)
			{
				tmp = romName+"=";
				tmp.Insert(0,"\n");	// make sure rom name starts at the beginning of a line.  otherwise we get stuff like "mk" matching up to "ddr3mk"!
				pos = m_catverData.Find(tmp);
				if ( (pos != -1) && (pos < catverAddedPos) )// found this rom in catver? (and not in the verAdded section only)
				{
					pos+=tmp.GetLength();
					pos2=m_catverData.Find("\n",pos);
					ROMType = m_catverData.Mid(pos,pos2-pos);
				}	
				else
				{
					ROMType="no_catver";
					logData+="Unable to find "+logName+" in catver.ini\r\n";
				}
				// inject the data into the rom description- this injects a "no_catver" if it wasn't found
				pos = m_ROMData.Find("<rom name=");
				pos --;
				tmp = "\t<category>"+ROMType+"</category>\n\t";
				m_ROMData.Insert(pos,tmp);
			}					


			// look up this rom name in nplayers.ini
			if (nPlayers)
			{
				tmp = romName+"=";
				tmp.Insert(0,"\n");	// make sure rom name starts at the beginning of a line.  otherwise we get stuff like "mk" matching up to "ddr3mk"!
				pos = m_nplayersData.Find(tmp);
				if (pos != -1)	// found in nplayers?
				{
					pos+=tmp.GetLength();
					pos2=m_nplayersData.Find("\n",pos);
					ROMType = m_nplayersData.Mid(pos,pos2-pos);
				}
				else
				{
					ROMType="no_nplayers";
					logData+="Unable to find "+logName+" in nplayers.ini\r\n";
				}
				// inject the data into this rom description
				pos = m_ROMData.Find("<rom name=");
				pos --;
				tmp = "\t<nplayers>"+ROMType+"</nplayers>\n\t";
				m_ROMData.Insert(pos,tmp);
			} //nPlayers flag (we have the file loaded)

			// now get the "version added" data from catver for this rom.
			if (catver)
			{
				tmp = romName+"=.";
				tmp.Insert(0,"\n");	// make sure rom name starts at the beginning of a line.  otherwise we get stuff like "mk" matching up to "ddr3mk"!
				pos = m_catverData.Find(tmp);
				if (pos != -1)
				{
					pos--;
					pos+=tmp.GetLength();
					pos2=m_catverData.Find("\n",pos);
					ROMType = m_catverData.Mid(pos,pos2-pos);
				}
				else
				{
					ROMType = "no_veradded";
					logData+="Unable to find "+logName+" in catver.ini\r\n";
				}

				pos = m_ROMData.Find("<rom name=");
				pos --;
				tmp = "\t<verAdded>"+ROMType+"</verAdded>\n\t";
				m_ROMData.Insert(pos,tmp);
			}

			// done with catver.  Look up this one in controls.xml


	//		RL.getROMDescription(m_ROMData, ROMDesc);
			
			// if this one is a clone, switch to the parent name so we can populate with controls.xml data
			// also search for the entire "game romname="romname" to better find matches.
			if (RL.gatherItem(m_ROMData,"cloneof=",tmp))
			{
				romName = tmp;
				logName += " (clone of "+tmp+")";
			}
			romName.Insert(0,"game romname=\"");
			romName.Append("\"");
		
			pos = controlsDatalc.Find(romName);
			if (pos != -1)
			{	// located in controls.xml good.
				// grab extra data from controls (cocktail=1, mirrored=0, numplayers=1 etc)
				pos = controlsDatalc.Find("numplayers=",pos);
				//pos+=ROMDesc.GetLength();
                //pos++;
				pos2 = controlsDatalc.Find(">", pos);
				tmp = m_controlsData.Mid(pos,pos2-pos);	// take from original to preserve case
				tmp.Trim();

				if (tmp.GetLength() > 0)
				{ // inject extra details into listXML data

					pos = m_ROMData.Find("<rom name=");
					pos --;
					tmp = "\t<controls_info>"+tmp+"</controls_info>\n\t";	// no space, thanks josh!
					m_ROMData.Insert(pos,tmp);
				}


/* grab player controls data
		<player number="1" numButtons="0">
			<controls>
				<control name="4-way Joystick">
					<constant name="joy4way"/>
				</control>
			</controls>
		<labels>
				<label name="P1_JOYSTICK_RIGHT" value="Right"/>
				<label name="P1_JOYSTICK_LEFT" value="Left"/>
				<label name="P1_JOYSTICK_DOWN" value="Down"/>
				<label name="P1_JOYSTICK_UP" value="Up"/>
			</labels>
		</player>
		</game>
*/
			pos = controlsDatalc.Find("<player",pos2);	// start search from previous location
			pos2 = controlsDatalc.Find("</game",pos);
			tmp = m_controlsData.Mid(pos,pos2-pos);	// take from original
			tmp.Trim();

			if (tmp.GetLength() > 0)
				{ // inject player controls details into listXML data

					pos = m_ROMData.Find("<rom name=");
					pos --;
					tmp = "\t"+tmp+"\n\t";
					m_ROMData.Insert(pos,tmp);
				}
			} // controls.xml data
			else
				logData+="Unable to find "+logName+" in controls.xml\r\n";


			
	// u_rebelScum patch to find all roms with multiple default=yes dipswitches 
/*
			int position=0,p,q;
			q=-1;
			while (position != -1)
			{
				RL.getXMLData(position, m_ROMData, "<dipswitch", tmp);
				p=tmp.Find("default=\"yes");
				if (p != -1)
					q=tmp.Find("default=\"yes",p+5);
				if (q !=-1)
					fwrite(m_ROMData, sizeof( char ), m_ROMData.GetLength(), outFile );
			}

*/
			// undo mame 162's formatting
			if (mame162)
			{
				m_ROMData.Replace("<machine name=","<game name=");
				m_ROMData.Replace("</machine>","</game>");
			}



		// Finished with this ROM description.
		// write this data out to the file
		fwrite(m_ROMData, sizeof( char ), m_ROMData.GetLength(), outFile );
	} // while we're still getting data

	m_ROMData = "\r\n"+footer;	// finish off with an XML footer
	fwrite(m_ROMData, sizeof( char ), m_ROMData.GetLength(), outFile );


	if ( outFile != NULL )
	{
		fclose(outFile);
		outFile=NULL;
	}

	if ( inFile != NULL )
	{
		fclose(inFile);
		outFile=NULL;
	}

	// write the log file
	outFile = fopen("mergelog.txt","wb");
	fwrite(logData, sizeof( char ), logData.GetLength(), outFile );
	fclose(outFile);


	progDlg.DestroyWindow();

}


// this utility scans a folder of roms and trims down the input xml file to match just the roms located.
void CROMListerSettingsDlg::OnBnClickedRomscanbtn()
{
	extern int g_xmlType;
	CString m_SourcePath, outfilename, infilename;
	CString m_xmlHeader;
	CString gamename;
	CString m_ROMData;
	CFileStuff fileStuff;
	CTime time = CTime::GetCurrentTime();
	CString d = time.Format( "%A, %B %d, %Y" );
	CString t = CTime::GetCurrentTime().Format("%H:%M");
	CString logData = "ROMLister rom scan utility log file.\r\nFile created on:"+d+"@"+t+"\r\n";
	FILE* inFile;
	FILE* outFile;
	xmlType xmlData;
	int key;
	CProgressDlg progDlg;
	CRl m_RL;

	// open a "browse to folder" dialog
	if (fileStuff.UserBrowseFolder(m_SourcePath, "Folder of ROMs to scan...") != TRUE)
		return;
	m_SourcePath+="\\";


	LPCTSTR FileFilter = "xml files (*.xml)\0*.xml\0";
	LPCTSTR FileExt = "xml";
	fileStuff.m_windowTitle = "Save scanned xml file as...";

	if (!fileStuff.UserBrowseSave(&outfilename, FileFilter, FileExt))
		return;	// cancelled


	// get the input filename
	m_outputFilename.GetWindowText(infilename);

	// open outputfile
	outFile = fopen(outfilename,"w");
	if (outFile == NULL)
	{
		AfxMessageBox("Error opening output file for write!?", MB_ICONEXCLAMATION, 0);
		return;
	}

	// open the input xml file
	inFile = fopen(infilename,"r");
	if (inFile == NULL)
	{
		AfxMessageBox("Error opening input xml file for reading!?", MB_ICONEXCLAMATION, 0);
		return;
	}
	logData +="XML input filename:"+infilename+"\r\n";

//AfxMessageBox("1) make initial list...", MB_ICONINFORMATION, 0);

	progDlg.Init(PROG_MODE_TIMER, 1000, "Indexing main input XML file...","This will likely take a few minutes.");
	m_RL.initialList();		// parse through the listXML file and generate a list of romnames+keys
CString txt;

txt.Format("2) initial list has %d entries.  \nThis should be the total count of roms this version of MAME supports", m_RL.m_count);
//AfxMessageBox(txt, MB_ICONINFORMATION, 0);


//AfxMessageBox("3) scan zips...", MB_ICONINFORMATION, 0);
	progDlg.UpdateText("Scanning zips and creating new xml file...");


	m_ROMFiles=0;

	// now we have the path+filename we want to work with.
	// scan all the files in this selected folder.
	m_ROMsDir.ClearDirs();
	m_ROMsDir.ClearFiles();
	// look in the user folder, not recursively
	m_ROMsDir.GetDirs(m_SourcePath, false);
	

   ///////////////////////////////////////////////////
   // get all files in the dirs we found above
   m_ROMsDir.GetFiles("*.zip");
   m_ROMsDir.GetFiles("*.7z");
   m_ROMsDir.GetFiles("*.chd");

   // sort them by name, ascending
   m_ROMsDir.SortFiles(CSADirRead::eSortAlpha, false);
   CSADirRead::SAFileVector &files = m_ROMsDir.Files();
   m_ROMFiles = files.begin();

//AfxMessageBox("4) get XML header...", MB_ICONINFORMATION, 0);
	// grab the xml file header so we can append it to the output
	fileStuff.getXMLHeader(inFile, m_xmlHeader);

//AfxMessageBox("5) get footer...", MB_ICONINFORMATION, 0);
	CString footer = fileStuff.getXMLFooter(m_xmlHeader);
	fwrite(m_xmlHeader, sizeof( char ), m_xmlHeader.GetLength(), outFile );

int filecount=0;
int foundcount=0;

	// for every file we locate...
   while ( m_ROMFiles != files.end())
   {
	    gamename = (*m_ROMFiles).m_sName;
		gamename.Replace(m_SourcePath,"");
		gamename.MakeLower();
		gamename.Replace(".zip","");  
		gamename.Replace(".7z",""); 
		gamename.Replace(".chd",""); 

		progDlg.UpdateText("Scanning and creating new xml file...",(*m_ROMFiles).m_sName);
		key = m_RL.lookupKey(gamename);
		if (key != -1)
		{
			progDlg.UpdateText("Adding game:",gamename);
			if (fileStuff.getROMDesc(inFile, m_ROMData, gamename, key) != -1)  // get everything from <game down to /game>
				fwrite(m_ROMData, sizeof( char ), m_ROMData.GetLength(), outFile );
			foundcount++;
		}
		else
		{
			logData +=gamename+" was not found in the xml file.\r\n";
		}
		m_ROMFiles++;	// next rom file
		filecount++;
   }
	txt.Format("Added %d entries into new XML file out of %d zip files found.", foundcount, filecount);
	logData +=txt;

txt.Format("6) added %d entries into new XML file out of %d zip files found.\n if these numbers are not the same, then there are .zip files that were not found in your XML source file.  ", foundcount, filecount);
//AfxMessageBox(txt, MB_ICONINFORMATION, 0);


	m_ROMData = "\r\n"+footer;	// finish off with an XML footer
	fwrite(m_ROMData, sizeof( char ), m_ROMData.GetLength(), outFile );

   if ( outFile != NULL )
	{
		fclose(outFile);
		outFile=NULL;
	}

	if ( inFile != NULL )
	{
		fclose(inFile);
		outFile=NULL;
	}
	// write the log file
	outFile = fopen("romscanlog.txt","wb");
	fwrite(logData, sizeof( char ), logData.GetLength(), outFile );
	fclose(outFile);


	progDlg.DestroyWindow();

	AfxMessageBox("Your xml file has been created.\r\nThis file is now set as your input xml file.\r\nLogfile generated as romscanlog.txt", MB_ICONINFORMATION, 0);
	m_outputFilename.SetWindowText(outfilename);

}

// convert a Mala List to XML
void CROMListerSettingsDlg::OnBnClickedMala2XML()
{
	CString malaFilePath;
	CFileStuff fileStuff;
	FILE* inFile;
	FILE* outFile;
	CRl RL;
	malaListHeader pMalaHeader;
	malaList pMalaData;
	int key;
	int ptr=0;
	CProgressDlg progDlg;
	CString filename;
	CString newXMLFile;
	CTime time = CTime::GetCurrentTime();
	CString d = time.Format( "%A, %B %d, %Y" );
	CString t = CTime::GetCurrentTime().Format("%H:%M");
	CString logData = "ROMLister list convert utility log file.\r\nFile created on:"+d+"@"+t+"\r\n";
	bool notFound=false;


	LPCTSTR FileFilter = "mlg files (*.mlg)\0*.mlg\0"; //all files (*.*)\0*.*\0";
	LPCTSTR FileExt = "mlg";
	fileStuff.m_windowTitle = "Open a mala list...";

	if (!fileStuff.UserBrowseOpen(&malaFilePath, FileFilter, FileExt))
		return;

	// open the input file
	inFile = fopen(malaFilePath,"rb");
	if (inFile == NULL)
	{
		AfxMessageBox("Error opening file for reading!?", MB_ICONEXCLAMATION, 0);
		return;
	}
	// get the file size...
	fseek(inFile, 0, SEEK_END);
    int size= ftell(inFile);

	fseek(inFile, 0, SEEK_SET);
	char* tgtBuffer = new char[size+4];	// extra padding in case we look past the end of the buffer
	tgtBuffer[size] = 01;

	memset(tgtBuffer,0,size);
	fread(tgtBuffer,size,1 ,inFile);
	fclose(inFile);	
	
	// first byte should be 01, then a 06 for "string"
	if ( (tgtBuffer[0] != 1) || (tgtBuffer[1] != 6) )
	{
		AfxMessageBox("Invalid Mala game list file?!?", MB_ICONEXCLAMATION, 0);
		return;
	}


	// Browse function to save the newly created XML file to.		
	FileFilter = "xml files (*.xml)\0*.xml\0";
	FileExt = "xml";
	fileStuff.m_windowTitle = "Save new XML file as...";

	if (!fileStuff.UserBrowseSave(&newXMLFile, FileFilter, FileExt))
	{	
		delete []tgtBuffer;
		return;	// cancelled
	}



	// create a temporary output xml file
	outFile = fopen(newXMLFile,"w");
	if (outFile == NULL)
	{
		AfxMessageBox("Error opening output file for write!?", MB_ICONEXCLAMATION, 0);
		delete []tgtBuffer;
		return;
	}

	// open the input merged XML file
	m_outputFilename.GetWindowText(filename);
	inFile = fopen(filename,"r");
	if (inFile == NULL)
	{
		AfxMessageBox("Error opening input xml file for reading!?", MB_ICONEXCLAMATION, 0);
		delete []tgtBuffer; // cleanup
		return;
	}
	
	progDlg.Init(PROG_MODE_TIMER, 1000, "Indexing main input XML file...","This will likely take a few minutes.");

	RL.initialList();		// parse through the listXML file and generate a list of romnames+keys


	// grab the xml file header so we can append it to the output
	fileStuff.getXMLHeader(inFile, m_xmlHeader);
	CString footer = fileStuff.getXMLFooter(m_xmlHeader);
	fwrite(m_xmlHeader, sizeof( char ), m_xmlHeader.GetLength(), outFile );





	ptr++;
	// read in three strings which always start with 06
	pMalaHeader.FName = RL.getMalaString(tgtBuffer, ptr); // 01 06 size
	pMalaHeader.FAuthor = RL.getMalaString(tgtBuffer, ptr); // 06 size
	pMalaHeader.FCreated = RL.getMalaString(tgtBuffer, ptr); // 06 size
	// then there is some extra data, which we don't care about.  Scan until we are sitting on a 06 again.
	while (tgtBuffer[ptr] != 06)
		ptr++;

//	ptr+=18; // skip over dates? // 11 6a ..
//	ptr+=7; // skip over misc?   // 08 02 46 02 00 00 01
	//pMalaHeader.FCreated = RL.getMalaString(tgtBuffer, ptr); 
	//pMalaHeader.FModified = RL.getMalaString(tgtBuffer, ptr); 
	//pMalaHeader.FComment = RL.getMalaString(tgtBuffer, ptr); 

	// should now be sitting on a mala entry.  Parse it

	int count=0;
	while (ptr < size)
	{
		RL.getMalaEntry(tgtBuffer, ptr, pMalaData);
		// do something with this entry
		
		key = RL.lookupKey(pMalaData.FName);
		if (key != -1)
		{
			progDlg.UpdateText("Adding game:",pMalaData.FName);
			if (fileStuff.getROMDesc(inFile, m_ROMData, pMalaData.FName, key) != -1)  // get everything from <game down to /game>
				fwrite(m_ROMData, sizeof( char ), m_ROMData.GetLength(), outFile );
		   m_ROMFiles++;	// next rom file
		}
		else
		{
			notFound=true;
			logData+="Unable to find "+pMalaData.FName+" in input XML. ROM name may have changed.\r\n";
		}
	}

	progDlg.DestroyWindow();
		
	m_ROMData = "\r\n"+footer;	// finish off with an XML footer
	fwrite(m_ROMData, sizeof( char ), m_ROMData.GetLength(), outFile );

	if ( outFile != NULL )
	{
		fclose(outFile);
		outFile=NULL;
	}

	AfxMessageBox("Your xml file has been created.\r\nThis file is now set as your input xml file.\r\n\r\nUse this new input XML file to generate an all ROMs list in the main romlister window.", MB_ICONINFORMATION, 0);
	m_outputFilename.SetWindowText(newXMLFile);

	
	// create the log file, if needed
	if (notFound)
	{
		outFile = fopen("convertLog.txt","w");
		if (outFile == NULL)
		{
			AfxMessageBox("Error opening log output file for write!?", MB_ICONEXCLAMATION, 0);
			delete []tgtBuffer;
			return;
		}
		fwrite(logData, sizeof( char ), logData.GetLength(), outFile );
		fclose(outFile);
		outFile=NULL;
		AfxMessageBox("Note!  At least one ROM name in the mlg file was not located in the master XML file.\r\nSee convertLog.txt for details.", MB_ICONINFORMATION, 0);
	}


	delete []tgtBuffer;
	
}

void CROMListerSettingsDlg::OnBnClickedxml2ini()
{
	FILE* inFile=NULL;
	FILE* outFile=NULL;
	CFileStuff fileStuff;
	CString outfileName;
	CString tmp;
	CString outline;
	CRl RL;
	CString playerTxt;
	CString players;
    CString controls;
	CString controlsData;
	int pnum;

	// browse to the xml file
	OnBnClickedControlsxmlbrowse();
	// open controls.xml
	if (m_controlsFilePath.GetLength() > 0)
		inFile = fopen(m_controlsFilePath,"r");
	if (inFile == NULL)
	{
		AfxMessageBox("Error opening input file!?", MB_ICONEXCLAMATION, 0);
		return;
	}


	// browse function to save the merged file to.		
	LPCTSTR FileFilter = "ini files (*.ini)\0*.ini\0";
	LPCTSTR FileExt = "ini";
	fileStuff.m_windowTitle = "Save new ini file as...";

	if (!fileStuff.UserBrowseSave(&outfileName, FileFilter, FileExt))
		return;	// cancelled


	// open outputfile
	outFile = fopen(outfileName,"wb");
	if (outFile == NULL)
	{
		AfxMessageBox("Error opening output file for write!?", MB_ICONEXCLAMATION, 0);
		return;
	}
	
	


	//fwrite(m_xmlHeader, sizeof( char ), m_xmlHeader.GetLength(), outFile );


	// main conversion loop
	while (fileStuff.getROMDesc(inFile, m_ROMData, "<Game RomName=") != -1)  // get everything from <game down to /game>
		{
			outline = "[";
			// get data elements
			RL.gatherItem(m_ROMData,"RomName=",tmp);
			outline+=tmp+"]\r\n";
			
			RL.gatherItem(m_ROMData,"GameName=",tmp);
			outline+="gamename="+tmp+"\r\n";

			RL.gatherItem(m_ROMData,"NumPlayers=",tmp);
			outline+="numplayers="+tmp+"\r\n";
			
			RL.gatherItem(m_ROMData,"Alternating=",tmp);
			outline+="alternating="+tmp+"\r\n";

			RL.gatherItem(m_ROMData,"Mirrored=",tmp);
			outline+="mirrored="+tmp+"\r\n";

			RL.gatherItem(m_ROMData,"Tilt=",tmp);
			outline+="tilt="+tmp+"\r\n";

			RL.gatherItem(m_ROMData,"Cocktail=",tmp);
			outline+="cocktail="+tmp+"\r\n";
	
			RL.gatherItem(m_ROMData,"UsesService=",tmp);
			outline+="usesService="+tmp+"\r\n";

			//RL.gatherItem(m_ROMData,"MiscDetails",tmp);
			outline+="miscdetails=skipped\r\n";

			// now it gets ugly
			pnum=1;
			int poffset=0;
			int buttonOffset;
			
			while(1)
			{
				poffset = RL.gatherItem(m_ROMData,"NumButtons=",tmp, poffset, false);
				if (tmp.GetLength()==0)
					break;
				playerTxt.Format("P%dNumButtons=",pnum);
				playerTxt+=tmp;
				playerTxt+="\r\n";
				outline+=playerTxt;

				playerTxt.Format("P%dControls=",pnum);
				poffset = RL.gatherItem(m_ROMData,"Control Name=",tmp,poffset,false);
				playerTxt+=tmp;

				poffset = RL.gatherItem(m_ROMData,"Constant Name=",tmp,poffset,false);
				if (tmp.GetLength() > 0)
				{
					playerTxt+="+";
					playerTxt+=tmp;
				}
				outline+=playerTxt+"\r\n";

				// now get the button function name
				buttonOffset=poffset;
				while(1)
				{
					buttonOffset = RL.gatherItem(m_ROMData,"Label Name=",tmp,buttonOffset,false);
					if (tmp.GetLength()==0)
						break;
					playerTxt=tmp+"=";
					buttonOffset = RL.gatherItem(m_ROMData,"Value=",tmp, buttonOffset,false);
					if (tmp.GetLength() == 0)
						tmp="Unspecified!";
					playerTxt+=tmp+"\r\n";
					outline+=playerTxt;
				}
				
				pnum++;
			}
				
			outline+="\r\n";
			fwrite(outline, sizeof( char ), outline.GetLength(), outFile );

		}


		// close input file
		if (inFile != NULL)
			fclose(inFile);	
		// close output file
		if (outFile != NULL)
			fclose(outFile);	
}

// scan a folder of zips and create a new XML file off their names
void CROMListerSettingsDlg::OnBnClickedRomdir2xml()
{
	extern int g_xmlType;
	CString m_SourcePath, outfilename, infilename;
	CString m_xmlHeader;
	CString gamename;
	CString m_ROMData;
	CFileStuff fileStuff;
//	FILE* inFile;
	FILE* outFile;
	xmlType xmlData;
	int pos;

	// open a "browse to folder" dialog
	if (fileStuff.UserBrowseFolder(m_SourcePath, "Folder of ROMs to use...") != TRUE)
		return;
	m_SourcePath+="\\";


	LPCTSTR FileFilter = "xml files (*.xml)\0*.xml\0";
	LPCTSTR FileExt = "xml";
	fileStuff.m_windowTitle = "Save new xml file as...";

	if (!fileStuff.UserBrowseSave(&outfilename, FileFilter, FileExt))
		return;	// cancelled


	// get the input filename
//	m_outputFilename.GetWindowText(infilename);

	// open outputfile
	outFile = fopen(outfilename,"wb");
	if (outFile == NULL)
	{
		AfxMessageBox("Error opening output file for write!?", MB_ICONEXCLAMATION, 0);
		return;
	}

	// open the input xml file
//	inFile = fopen(infilename,"r");
//	if (inFile == NULL)
//	{
//		AfxMessageBox("Error opening input xml file for reading!?", MB_ICONEXCLAMATION, 0);
//		return;
//	}

	CProgressDlg progDlg;
	progDlg.Init(PROG_MODE_TIMER, 1000, "Scanning and creating new xml file...");


	m_ROMFiles=0;

	// now we have the path+filename we want to work with.
	// scan all the files in this selected folder.
	m_ROMsDir.ClearDirs();
	m_ROMsDir.ClearFiles();
	// look in the user folder, not recursively
	m_ROMsDir.GetDirs(m_SourcePath, false);


   ///////////////////////////////////////////////////
   // get all files in the dirs we found above
   m_ROMsDir.GetFiles("*.zip");
   m_ROMsDir.GetFiles("*.7z");

   // sort them by name, ascending
   m_ROMsDir.SortFiles(CSADirRead::eSortAlpha, false);
   CSADirRead::SAFileVector &files = m_ROMsDir.Files();
   m_ROMFiles = files.begin();


	// grab the xml file header so we can append it to the output
//	fileStuff.getXMLHeader(inFile, m_xmlHeader);

	//todo make an XML header here
	m_xmlHeader = "<?xml version=\"1.0\"?>\r\n";
	m_xmlHeader+="<!-- ROMDir2XML generated by ROMLister -->\r\n";
	//m_xmlHeader+="]>\r\n";
	m_xmlHeader+="<romdir2xml>\r\n";
	fwrite(m_xmlHeader, sizeof( char ), m_xmlHeader.GetLength(), outFile );



   while ( m_ROMFiles != files.end())
   {
	   gamename = "\t<game name=\""+(*m_ROMFiles).m_sName+"\">\r\n";
	   gamename+="\t\t<description>"+(*m_ROMFiles).m_sName+"</description>\r\n";
	   gamename+="\t\t<year>";
	   
	   // if we're dealing with TOSEC standard naming "game name (year)(publisher)" filenames, we can extract the year and manufacturer out of that data.
	   pos =(*m_ROMFiles).m_sName.Find(")(");
	   if ( (pos != -1) && ((*m_ROMFiles).m_sName.Mid(pos-5,1) == "(") )	
	   {
			gamename+=(*m_ROMFiles).m_sName.Mid(pos-4,4);	// extract year
			gamename+="</year>\r\n";
			gamename+="\t\t<manufacturer>";
			pos+=2;	// skip past )(
			gamename+=(*m_ROMFiles).m_sName.Mid(pos, ( (*m_ROMFiles).m_sName.Find(")",pos)-pos) );
			gamename+="</manufacturer>\r\n";

	   }
	   else
	   {
			gamename+="????";
			gamename+="</year>\r\n";
			gamename+="\t\t<manufacturer>Unknown</manufacturer>\r\n";
	   }
	   gamename.Replace(".zip","");  
	   gamename.Replace(".7z","");  
	   gamename.Replace(m_SourcePath,"");
	   
	   gamename+="\t</game>\r\n";
	   progDlg.UpdateText("Scanning and creating new xml file...",(*m_ROMFiles).m_sName);


	   //if (fileStuff.getROMDesc(inFile, m_ROMData, gamename, 0) != -1)  // get everything from <game down to /game>
	   fwrite(gamename, sizeof( char ), gamename.GetLength(), outFile );
	   m_ROMFiles++;	// next rom file
   }
	
 

	CString xmlFooter = fileStuff.getXMLFooter(m_xmlHeader);
	fwrite(xmlFooter, sizeof( char ), xmlFooter.GetLength(), outFile );

   if ( outFile != NULL )
	{
		fclose(outFile);
		outFile=NULL;
	}

	progDlg.DestroyWindow();

	AfxMessageBox("Your xml file has been created.\r\nThis file is now set as your input xml file.", MB_ICONINFORMATION, 0);
	m_outputFilename.SetWindowText(outfilename);

}

// get an input list and break it into just the romname.  this will take a bit of effort to detect the type...
// once we have a romname, we can then use the rom scan utility functions to get the data from listXML to create a new list.
void CROMListerSettingsDlg::OnBnClickedListconvert()
{
	CString maxData;
	CString filename;
	CString gamename;
	CString tmp;
	CFileStuff fileStuff;
	CString listXMLData;
	FILE* inputList;
	FILE* outFile;
	FILE* inFile;	// merged XML file
	CRomListerDlg mainDlg;
	CRl m_RL;
	int key;
	CProgressDlg progDlg;

	LPCTSTR FileFilter = "Maximus files (*.txt)\0*.txt\0xml files (*.xml)\0*.xml\0"; //all files (*.*)\0*.*\0";
	LPCTSTR FileExt = "txt;xml";
	fileStuff.m_windowTitle = "Point me to a Maximus file please...";

	if (fileStuff.UserBrowseOpen(&fileStuff.m_sFilePath, FileFilter, FileExt))
	{
		inputList = fopen(fileStuff.m_sFilePath,"r");
		if (inputList != NULL)
			fileStuff.loadFile(inputList, maxData);
		// close input file
		if (inputList != NULL)
			fclose(inputList);	

		// create a temporary output xml file
		outFile = fopen("c:\\tempXMLFile.xml","w");
		if (outFile == NULL)
		{
			AfxMessageBox("Error opening output file for write!?", MB_ICONEXCLAMATION, 0);
			return;
		}

		// open the input merged XML file
		m_outputFilename.GetWindowText(filename);
		inFile = fopen(filename,"r");
		if (inFile == NULL)
		{
			AfxMessageBox("Error opening input xml file for reading!?", MB_ICONEXCLAMATION, 0);
			return;
		}
	
		progDlg.Init(PROG_MODE_TIMER, 1000, "Indexing main input XML file...");

		m_RL.initialList();		// parse through the listXML file and generate a list of romnames+keys


		// grab the xml file header so we can append it to the output
		fileStuff.getXMLHeader(inFile, m_xmlHeader);
		CString footer = fileStuff.getXMLFooter(m_xmlHeader);
		fwrite(m_xmlHeader, sizeof( char ), m_xmlHeader.GetLength(), outFile );
	
		// spin through the maximus data and extract a romname
		// each maximus entry looks like this: "1942 (Revision A)": [#name: "1942a", #path: "C:\path\"], 
		// we want to extract the romname, which is always in quotes after #name:
		
		// strip out the leading and tailing [ ]'s and prep the MA list to prepare for parsing
		maxData.TrimLeft("\"[");
		maxData.TrimRight("]");
		maxData.Append("],");

		while (!maxData.IsEmpty() )
		{
			// extract 1 complete entry from the maximus data
			int i=0;
			tmp = maxData.Tokenize("]",i);
			//tmp+=",";
			//i++;
			//tmp +=maxData.Tokenize("]",i);
			tmp+="],";

			maxData.Replace(tmp,"");	// remove the entry from the list
			maxData.TrimLeft("\" ");

			// extract the rom name from the entry
			i=0;
			gamename = tmp.Tokenize("\"",i);
			gamename = tmp.Tokenize("\"",i);
			gamename = tmp.Tokenize("\"",i);	// this is the token with the romname in it.
			gamename.Trim("\"");
			key = m_RL.lookupKey(gamename);
			if (key != -1)
			{
				progDlg.UpdateText("Adding game:",gamename);
				if (fileStuff.getROMDesc(inFile, m_ROMData, gamename, key) != -1)  // get everything from <game down to /game>
					fwrite(m_ROMData, sizeof( char ), m_ROMData.GetLength(), outFile );
			   m_ROMFiles++;	// next rom file
			}
		}	// each maximus entry

		progDlg.DestroyWindow();
		
		m_ROMData = "\r\n"+footer;	// finish off with an XML footer
		fwrite(m_ROMData, sizeof( char ), m_ROMData.GetLength(), outFile );

		if ( outFile != NULL )
		{
			fclose(outFile);
			outFile=NULL;
		}

		AfxMessageBox("Your xml file has been created.\r\nThis file is now set as your input xml file.\r\n\r\nUse this new input XML file to generate an all ROMs list in the main romlister window.", MB_ICONINFORMATION, 0);
		m_outputFilename.SetWindowText("c:\\tempXMLFile.xml");

	}	// input MA list
}
