// RomListerDlg.cpp : implementation file
//
/*
todo: prev/next buttons to work on searched xml




[file menu]->all save formats
[QFW] tabbed?  that'd be crazy.
-find:

[rom lookup]->floating window [hide rom info]
^
|
+-- need rom/description maybe, and a way to search for the next one. (search again)

[go]->gathers items ->floating window of description/romname/year/manufacturer under headings
sortable headings, adjustable columns.
right click->examine xml, delete entry
[examine xml]->floating window [hide rom info]

add ? for wildcards?
> < = for math?




*/
#include "stdafx.h"
#include "RomLister.h"
#include "RomListerDlg.h"
#include ".\romlisterdlg.h"
#include "progressDlg.h"

#include "mamebrowser.h"
#include "searchDlg.h"
#include "xmlType.h"
#include "ROMListerSettingsDlg.h"
#include "errorMessage.h"
#include "RLOutput.h"
#include "RLAllROMsListDlg.h"
#include "RLSearchItemsListDlg.h"
#include "GenericOutputDlg.h"
#include "similar.h"
#include "SearchHistoryDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CRomListerDlg dialog
CRomListerDlg::CRomListerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRomListerDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRomListerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
//	DDX_Control(pDX, IDC_ROMDESC, m_RomDescTxt);
	DDX_Control(pDX, IDC_CMDLINE, m_cmdLine);
	DDX_Control(pDX, IDC_NUMBUTTONS, m_numButtons);
//	DDX_Control(pDX, IDC_CATEGORYTYPE, m_categoryType);
	DDX_Control(pDX, IDC_REGION, m_region);
}

BEGIN_MESSAGE_MAP(CRomListerDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
//	ON_BN_CLICKED(IDC_VIEWINPUT, OnBnClickedViewinput)
//	ON_BN_CLICKED(IDC_VIEWOUTPUT, OnBnClickedViewoutput)
	ON_BN_CLICKED(IDC_COCKTAILONLY, OnBnClickedCocktailonly)
	ON_BN_CLICKED(IDC_UPRIGHT, OnBnClickedUpright)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDC_CATANY, OnBnClickedCatany)
	ON_CONTROL_RANGE(BN_CLICKED, IDC_NUMBUTTONS, IDC_TXTROM, OnBnClickedTweakCmdLine)
	ON_CONTROL_RANGE(BN_CLICKED, IDC_BALLPADDLE, IDC_CATANY, OnBnClickedTweakCmdLine)	// categories
	ON_CONTROL_RANGE(BN_CLICKED, IDC_NPLYR2ALT, IDC_NPLYR1, OnBnClickedTweakCmdLine)	// nplayers
	ON_CBN_SELCHANGE(IDC_NUMBUTTONS, OnCbnSelchangeNumbuttons)
//	ON_BN_CLICKED(IDC_NEXTROMDESC, OnBnClickedNextromdesc)
//	ON_BN_CLICKED(IDC_PREVROMDESC, OnBnClickedPrevromdesc)
	ON_BN_CLICKED(IDC_ROMSEARCH, OnBnClickedRomsearch)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
//	ON_CONTROL_RANGE(BN_CLICKED, IDC_XMLOUT, IDC_ROMDESCONLY, OnBnClickedoutputTypeRange)
	ON_BN_CLICKED(IDC_SETTINGS, OnBnClickedSettings)
//	ON_CBN_SELCHANGE(IDC_CATEGORYTYPE, OnCbnSelchangeCategorytype)
	ON_CBN_SELCHANGE(IDC_REGION, OnCbnSelchangeRegion)
	ON_BN_CLICKED(IDC_REGION_NOT, OnBnClickedRegionNot)
	ON_BN_CLICKED(IDC_LISTALLROMS, OnBnClickedListallroms)

//	ON_BN_CLICKED(IDC_PREVSEARCHBTN, OnBnClickedPrevsearchbtn)
	ON_BN_CLICKED(IDC_NEXTSEARCHBTN, OnBnClickedNextsearchbtn)
END_MESSAGE_MAP()


// CRomListerDlg message handlers

BOOL CRomListerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	extern int g_xmlType;
	extern CRLOutPutDlgThd* gm_pRLOutputThd;
	extern CRLAllROMsDlgThd* gm_pRLAllROMsThd;
	extern CRLSearchItemsThd* gm_pRLSearchItemsThd;

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	// need to go into the settings dialog?
	if (m_gotoOptions)
		OnBnClickedSettings();
	else
		loadInputFile();

	m_anyCheck = true;		// "or less" checkbox is now checked. 
	OnBnClickedUpright();
	m_numButtons.SetCurSel(3);		// 2 buttons
	((CButton*)GetDlgItem(IDC_CATANY))->SetCheck(1);	// any category
	OnBnClickedCatany();

	for (int i=IDC_NPLYR2ALT; i<=IDC_NPLYR1; i++)
		((CButton*)GetDlgItem(i))->SetCheck(2);


//	m_categoryType.SetCurSel(0);	// any category
	m_region.SetCurSel(0);			// any region
	OnCbnSelchangeRegion();			// gray out the region not
	((CButton*)GetDlgItem(IDC_NOPRELIMINARY))->SetCheck(1);
	((CButton*)GetDlgItem(IDC_ORLESSBUTTONS))->SetCheck(1);
	((CButton*)GetDlgItem(IDC_JOY2WAY))->SetCheck(1);
	((CButton*)GetDlgItem(IDC_JOY4WAY))->SetCheck(1);
	((CButton*)GetDlgItem(IDC_BUTTONSONLY))->SetCheck(1);
	OnBnClickedTweakCmdLine(0);
//	enableWizard(1);
//	m_fOutputListOpen = false;
	theApp.m_fAllListOpen = false;

	// start threads for output list and allroms list

	// open the output window dialog in a UI thread
	gm_pRLAllROMsThd = (CRLAllROMsDlgThd*)AfxBeginThread(RUNTIME_CLASS(CRLAllROMsDlgThd));
	if ( gm_pRLAllROMsThd == NULL )
		{
			AfxMessageBox("Unable to create full list window thread!?!", MB_ICONERROR, 0);
			return FALSE;
		}

	// open the output window dialog in a UI thread
	gm_pRLOutputThd = (CRLOutPutDlgThd*)AfxBeginThread(RUNTIME_CLASS(CRLOutPutDlgThd));
	if ( gm_pRLOutputThd == NULL )
		{
			AfxMessageBox("Unable to create output window thread!?!", MB_ICONERROR, 0);
			return FALSE;
		}

	gm_pRLSearchItemsThd =(CRLSearchItemsThd*)AfxBeginThread(RUNTIME_CLASS(CRLSearchItemsThd));
	if ( gm_pRLSearchItemsThd == NULL )
		{
			AfxMessageBox("Unable to create search window thread!?!", MB_ICONERROR, 0);
			return FALSE;
		}


	// set up some pointers.
	// we have pointers to each thread available, and each thread can see mainframe
	// m_pwndAllROMsListDlg is a pointer to the all roms dialog
	// m_pwndRLOutput is a pointer to the working list dialog - these are both in the thread code
	gm_pRLAllROMsThd->m_pMainFrame = this;			// a return pointer from the thread back to here
	gm_pRLOutputThd->m_pMainFrame = this;
	gm_pRLSearchItemsThd->m_pMainFrame = this;

	loadHistory();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRomListerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
//	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
//	{
//		CAboutDlg dlgAbout;
//		dlgAbout.DoModal();
//	}
//	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRomListerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRomListerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CRomListerDlg::OnBnClickedCocktailonly()
{
	((CButton*)GetDlgItem(IDC_COCKTAILONLY))->SetCheck(1);
	((CButton*)GetDlgItem(IDC_UPRIGHT))->SetCheck(0);	 
	OnBnClickedTweakCmdLine(0);
}

void CRomListerDlg::OnBnClickedUpright()
{
	((CButton*)GetDlgItem(IDC_COCKTAILONLY))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_UPRIGHT))->SetCheck(1);
	OnBnClickedTweakCmdLine(0);
}

void CRomListerDlg::OnBnClickedCancel()
{
	extern FILE* m_pinputFile;
	extern 	CRLOutput* gm_pwndRLOutput;
	extern	CString prevSearches[MAX_SEARCHES];
	FILE* outFile;
	extern CString g_sRLpath;
	CString searchHeader = "; ROMLister search history file.\r\n;Up to 25 previous searches are saved and can be maintained by editing this file or using the H button on the main GUI.\r\n";
	//extern CRLAllROMsListDlg* gm_pwndAllROMsListDlg;
	//extern CRLOutPutDlgThd* gm_pRLOutputThd;
	//extern CRLAllROMsDlgThd* gm_pRLAllROMsThd;
	//extern CRLSearchItemsThd* gm_pRLSearchItemsThd;

	gm_pwndRLOutput->OnBnClickedCancel();
	gm_pwndRLOutput->DestroyWindow();
	
	// close input file
	if (m_pinputFile != NULL)
		fclose(m_pinputFile);

	// save the search history data
	outFile = fopen(g_sRLpath+"searchHistory.txt","w");
	if (outFile == NULL)
	{
		AfxMessageBox("Error opening search history file for write!?", MB_ICONEXCLAMATION, 0);
		OnCancel();
	}
	fwrite(searchHeader, sizeof( char ), searchHeader.GetLength(), outFile );
	for (int i=0; i<MAX_SEARCHES; i++)
	{
		prevSearches[i].Append("\r\n");
		fwrite(prevSearches[i], sizeof( char ), prevSearches[i].GetLength(), outFile );
	}
	fclose(outFile);
	outFile=NULL;

	OnCancel();
}
void CRomListerDlg::OnCbnSelchangeNumbuttons()
{
	if (m_numButtons.GetCurSel() < 2) // 0=any, 1=0  remove 'or less' option
	{
		((CButton*)GetDlgItem(IDC_ORLESSBUTTONS))->EnableWindow(0);
		m_anyCheck = false;
	}
	else
	{
		((CButton*)GetDlgItem(IDC_ORLESSBUTTONS))->EnableWindow(1);
		m_anyCheck = true;
	}
	OnBnClickedTweakCmdLine(0);
}
// everytime a checkbox is changed, modify the command line
// there are probably better ways to do this...
void CRomListerDlg::OnBnClickedTweakCmdLine(unsigned int ID)
{
	extern int g_xmlType;
	CString criteria;
	m_cmdLineTxt="";	// start with a fresh command line

	if (doCocktail(criteria))
		m_cmdLineTxt+=criteria+" & ";
	if (doButtons(criteria))
		m_cmdLineTxt+=criteria+" & ";
	if (doVertical(criteria))
		m_cmdLineTxt+=criteria+" & ";
	if (doHorizontal(criteria))
		m_cmdLineTxt+=criteria+" & ";
	if (doControls(criteria))
		m_cmdLineTxt+=criteria+" & ";
	if (doRegions(criteria))
		m_cmdLineTxt+=criteria+" & ";
	if ( (g_xmlType == MAME) || (g_xmlType == merged) )
	{
	if (doMisc(criteria))
		m_cmdLineTxt+=criteria+" & ";
	}
	if (doCategory(criteria))
		m_cmdLineTxt+=criteria+" & ";

	if (doNplayers(criteria))
		m_cmdLineTxt+=criteria+" & ";

	m_cmdLineTxt.TrimRight("& ");

	 m_cmdLine.SetWindowText(m_cmdLineTxt);
}


// buttons.  Handles 0-10 or less.
bool CRomListerDlg::doButtons(CString &criteria)
{
	extern int g_xmlType;
	xmlType xmlData;
	
	int tmp;
	CString txt;
	criteria = "";
	tmp = m_numButtons.GetCurSel();
	
	if (tmp ==0) // any?  skip this section
		return false;

	tmp--; // make zero based.

	if ( ((CButton*)GetDlgItem(IDC_ORLESSBUTTONS))->GetCheck() ) // if or less checked, we need a string of criteria
	{
		criteria +="(";
		for (int i=tmp; i>0; i--)
		{
			criteria+=xmlData.buttons;  //"buttons=";
			txt.Format("%1d", i);
			criteria+=txt+" | ";
		}
		// handle 0 buttons
		criteria+="buttons=0 | !buttons=)";
	//	if (g_xmlType == MAME) criteria+="!buttons=)";
	//	else  criteria+="numButtons=0)"; // controls/merged.xml
		
	}
	else	// just a single criteria, no parenthesis required.
	{
		if ( (tmp == 0) && g_xmlType == MAME) // 0 buttons selected in MAME xml?
			criteria="!buttons=";
		else // 
		{
			txt.Format("%1d", tmp);
			criteria=xmlData.buttons+txt;  // add buttons=x or numButtons=x
		}
	}
	return true;
}

// vertical orientation
bool CRomListerDlg::doVertical(CString &criteria)
{
	criteria = "";
	// both boxes are checked, just ignore the whole thing.	
	if ( ((CButton*)GetDlgItem(IDC_ORIENT_VERT))->GetCheck() && !((CButton*)GetDlgItem(IDC_ORIENT_HORZ))->GetCheck() )
	{
		criteria=m_verticalTxt;
		return true;
	}
	else 
        return false;
}

// horizontal orientation
bool CRomListerDlg::doHorizontal(CString &criteria)
{
	criteria = "";
	// both boxes are checked, just ignore the whole thing.
	if ( ((CButton*)GetDlgItem(IDC_ORIENT_HORZ))->GetCheck()  && !((CButton*)GetDlgItem(IDC_ORIENT_VERT))->GetCheck() )
	{
		criteria=m_horizontalTxt;  
		return true;
	}
	else
		return false;
}
// cocktail only
bool CRomListerDlg::doCocktail(CString &criteria)
{
	extern int g_xmlType;
	xmlType xmlData;
	
	criteria = "";
	if ( ((CButton*)GetDlgItem(IDC_COCKTAILONLY))->GetCheck() )
	{
		criteria=xmlData.cocktail;
		return true;
	}
	else 
        return false;
}



// controls
bool CRomListerDlg::doControls(CString &criteria)
{
	criteria = "";
	CString yes, no;

	if ( ((CButton*)GetDlgItem(IDC_JOY2WAY))->GetCheck() == 1  )
		yes+="joy2way | ";
	if ( ((CButton*)GetDlgItem(IDC_JOY2WAY))->GetCheck() == 0  )
		no+="joy2way | ";

	if ( ((CButton*)GetDlgItem(IDC_JOY4WAY))->GetCheck() == 1 )
		yes +="joy4way | ";
	if ( ((CButton*)GetDlgItem(IDC_JOY4WAY))->GetCheck() == 0 )
		no +="joy4way | ";

	if ( ((CButton*)GetDlgItem(IDC_JOY8WAY))->GetCheck() ==1 )
		yes +="joy8way | ";
	if ( ((CButton*)GetDlgItem(IDC_JOY8WAY))->GetCheck() ==0 )
		no +="joy8way | ";

	if ( ((CButton*)GetDlgItem(IDC_49WAYSTICK))->GetCheck() ==1 )
		yes +="49-way | ";
	if ( ((CButton*)GetDlgItem(IDC_49WAYSTICK))->GetCheck() ==0 )
		no +="49-way | ";

	if ( ((CButton*)GetDlgItem(IDC_TRIGGER))->GetCheck() ==1 )
		yes +="triggerstick | ";
	if ( ((CButton*)GetDlgItem(IDC_TRIGGER))->GetCheck() ==0 )
		no +="triggerstick | ";

	if ( ((CButton*)GetDlgItem(IDC_TOPFIRE))->GetCheck() ==1 )
		yes +="top-fire | ";
	if ( ((CButton*)GetDlgItem(IDC_TOPFIRE))->GetCheck() ==0 )
		no +="top-fire | ";

	if ( ((CButton*)GetDlgItem(IDC_ROTARY))->GetCheck()==1  )
		yes +="rotary | ";
	if ( ((CButton*)GetDlgItem(IDC_ROTARY))->GetCheck()==0  )
		no +="rotary | ";

	if ( ((CButton*)GetDlgItem(IDC_DUAL8WAY))->GetCheck()==1  )
		yes +="doublejoy8way | ";
	if ( ((CButton*)GetDlgItem(IDC_DUAL8WAY))->GetCheck()==0  )
		no +="doublejoy8way | ";

	if ( ((CButton*)GetDlgItem(IDC_DUAL4WAY))->GetCheck()==1  )
		yes +="doublejoy4way | ";
	if ( ((CButton*)GetDlgItem(IDC_DUAL4WAY))->GetCheck()==0  )
		no +="doublejoy4way | ";

	if ( ((CButton*)GetDlgItem(IDC_DUAL2WAY))->GetCheck()==1  )
		yes +="doublejoy2way | ";
	if ( ((CButton*)GetDlgItem(IDC_DUAL2WAY))->GetCheck()==0  )
		no +="doublejoy2way | ";

	if ( ((CButton*)GetDlgItem(IDC_SPINNER))->GetCheck()==1  )
		yes +="dial | ";
	if ( ((CButton*)GetDlgItem(IDC_SPINNER))->GetCheck()==0  )
		no +="dial | ";

	if ( ((CButton*)GetDlgItem(IDC_TRACKBALL))->GetCheck() ==1 )
		yes +="trackball | ";
	if ( ((CButton*)GetDlgItem(IDC_TRACKBALL))->GetCheck() ==0 )
		no +="trackball | ";
	
	if ( ((CButton*)GetDlgItem(IDC_PEDAL))->GetCheck()==1  )
		yes +="pedal | ";
	if ( ((CButton*)GetDlgItem(IDC_PEDAL))->GetCheck()==0  )
		no +="pedal | ";

	if ( ((CButton*)GetDlgItem(IDC_LIGHTGUN))->GetCheck() ==1 )
		yes +="lightgun | ";
	if ( ((CButton*)GetDlgItem(IDC_LIGHTGUN))->GetCheck() ==0 )
		no +="lightgun | ";

	if ( ((CButton*)GetDlgItem(IDC_ANALOGSTICK))->GetCheck() ==1 )
		yes +="'Analog' | ";
	if ( ((CButton*)GetDlgItem(IDC_ANALOGSTICK))->GetCheck() ==0 )
		no +="'Analog' | ";

	if ( ((CButton*)GetDlgItem(IDC_BUTTONSONLY))->GetCheck() ==1 )
		yes +="!'control type=' | ";
	if ( ((CButton*)GetDlgItem(IDC_BUTTONSONLY))->GetCheck() ==0 )
		no +="!'control type=' | ";




	yes.TrimRight(" |");
	no.TrimRight(" |");
	if (yes.GetLength() != 0)
        criteria +="("+yes+")";
	if (no.GetLength() != 0)
		criteria +=" !("+no+")";

	criteria.Replace(") !(",") & !(");
	if (criteria.GetLength() > 0)
		return true;
	else
		return false;
	
}
// Misc controls
bool CRomListerDlg::doMisc(CString &criteria)
{
	criteria = "";
	if ( ((CButton*)GetDlgItem(IDC_NOCLONES))->GetCheck() )
		criteria +="!cloneof ";

	if ( ((CButton*)GetDlgItem(IDC_NOSAMPLES))->GetCheck() )
		criteria +="!sample_name= ";

	if ( ((CButton*)GetDlgItem(IDC_NOPRELIMINARY))->GetCheck() )
		criteria +="!emulation=preliminary ";




	criteria.TrimRight();
	if (criteria.Replace(" "," & "))
	{
		criteria.Insert(0,"(");
		criteria.Append(")");
	}

	if (criteria.GetLength() == 0) 
		return false;
	else
		return true;

}
/* regions
Josh Van Nieuwenhoven:
It's not bullet proof, but I think its a pretty solid start. Here is my algorithm:
 
Algorithm: (based on "description")
- User selects region.
- Form a XML file
- Select all games whose description matches that regions criteria
- Skip over all games that match that criteria but do not match other regions
criteria. This will eliminate games like "Daytona USA (Japan)"
- If the game is "(World)" add it no matter what. Same would hold true of "(Europe /
USA / Japan / Asia)" , "(International/Japan)", "(JPN, USA, EXP, KOR, AUS)"
- If the user wants clones, go back through the list and find the parent rom.
- Add that game to the file so if they transfer games the game works.

ASIA:
"(Europe / USA / Japan / Asia)"
"(Asia "
"(Euro/Asia "
"(Asia, "
"(Europe/Asia "
" Asia)"
"(Asia/Europe"
"(International/Japan)"
"(World)"
 
( '(Europe / USA / Japan / Asia)' | '(Asia ' | '(Euro/Asia ' | '(Asia, ' | '(Europe/Asia ' | ' Asia)' | '(Asia/Europe' | '(International/Japan)' | '(World)' )
@ASIA


USA:
" USA "
"(USA "
"(USA, "
"USA (Japan)"
"USA (Japan, "
"(JPN, USA, EXP, KOR, AUS)"
"(USA)"
"(International/Japan)"
"(US)"
"(US?)"
"(US,"
"(US "
"(Europe / USA / Japan / Asia) "
", US"
"(World)"

( ' USA ' | '(USA ' | '(USA, ' | 'USA (Japan)' | 'USA (Japan, ' | '(JPN, USA, EXP, KOR, AUS)' | '(USA)' | '(International/Japan)' | '(US)' | '(US?)' | '(US,' | '(US ' | '(Europe / USA / Japan / Asia) ' | ', US' | '(World)' )
@USA


EURO:
"(Europe "
"(Euro)"
"(Euro "
(Euro,"
" Euro "
"(Europe, "
" European "
"(Asia/Europe"
"(Europe/Asia "
" Europe)"
"(European)"
"(Europe / USA / Japan / Asia)"
"(International/Japan)"
"(World)"


( '(Europe ' | '(Euro)' | '(Euro ' | '(Euro,' | ' Euro ' | '(Europe, ' | ' European ' | '(Asia/Europe' | '(Europe/Asia ' | ' Europe)' | '(European)' | '(Europe / USA / Japan / Asia)' | '(International/Japan)' | '(World)' )
@EURO


JAPAN:
"(JPN, USA, EXP, KOR, AUS)"
"(Japan "
"(Japan)"
"(Japan, "
", Japan)"
"(Japan?)"
"(Europe / USA / Japan / Asia)"
"(International/Japan)"
"(Japan, Japanese)"
"(Japan, English)"
" Japan "
" Japan,"
", Japan,"
" Japanese "
", Japanese"
"(World)"


( '(JPN, USA, EXP, KOR, AUS)' | '(Japan ' | '(Japan)' | '(Japan, ' | ', Japan)' | '(Japan?)' | '(Europe / USA / Japan / Asia)' | '(International/Japan)' | '(Japan, Japanese)' | '(Japan, English)' | ' Japan ' | ' Japan,' | ', Japan,' | ' Japanese ' | ', Japanese' | '(World)' )
@JAPAN

*/
bool CRomListerDlg::doRegions(CString &criteria)
{
	criteria = "";
	if ( m_region.GetCurSel() == 1 )
		criteria +="@USA ";

	if ( m_region.GetCurSel() == 2 )
		criteria +="@JAPAN ";


	if ( m_region.GetCurSel() == 3 )
		criteria +="@EURO ";

	if ( m_region.GetCurSel() == 4 )
		criteria +="@ASIA ";



	if ( ( ((CButton*)GetDlgItem(IDC_REGION_NOT))->GetCheck() ) && (m_region.GetCurSel() != 0) )
	{
		criteria.Insert(0,"!");
	}

	criteria.TrimRight();

	if (criteria.GetLength() == 0) 
		return false;
	else
		return true;

}
// nPlayers
/*
nplayer types
1P
2P alt
2P sim
3P sim
4P alt
4P sim
*/
bool CRomListerDlg::doNplayers(CString &criteria)
{
	criteria = "";
	CString yes, no;

	if ( ((CButton*)GetDlgItem(IDC_NPLYR1))->GetCheck() == 1  )
		yes+="'<nplayers>1P<' | ";
	if ( ((CButton*)GetDlgItem(IDC_NPLYR1))->GetCheck() == 0  )
		no+="'<nplayers>1P<' | ";

	if ( ((CButton*)GetDlgItem(IDC_NPLYR2ALT))->GetCheck() == 1  )
		yes+="'<nplayers>2P alt<' | ";
	if ( ((CButton*)GetDlgItem(IDC_NPLYR2ALT))->GetCheck() == 0  )
		no+="'<nplayers>2P alt<' | ";

	if ( ((CButton*)GetDlgItem(IDC_NPLYR3ALT))->GetCheck() == 1  )
		yes+="'<nplayers>3P alt<' | ";
	if ( ((CButton*)GetDlgItem(IDC_NPLYR3ALT))->GetCheck() == 0  )
		no+="'<nplayers>3P alt<' | ";

	if ( ((CButton*)GetDlgItem(IDC_NPLYR4ALT))->GetCheck() == 1  )
		yes+="'<nplayers>4P alt<' | ";
	if ( ((CButton*)GetDlgItem(IDC_NPLYR4ALT))->GetCheck() == 0  )
		no+="'<nplayers>4P alt<' | ";

	if ( ((CButton*)GetDlgItem(IDC_NPLYR2SIM))->GetCheck() == 1  )
		yes+="'<nplayers>2P sim<' | ";
	if ( ((CButton*)GetDlgItem(IDC_NPLYR2SIM))->GetCheck() == 0  )
		no+="'<nplayers>2P sim<' | ";

	if ( ((CButton*)GetDlgItem(IDC_NPLYR3SIM))->GetCheck() == 1  )
		yes+="'<nplayers>3P sim<' | ";
	if ( ((CButton*)GetDlgItem(IDC_NPLYR3SIM))->GetCheck() == 0  )
		no+="'<nplayers>3P sim<' | ";

	if ( ((CButton*)GetDlgItem(IDC_NPLYR4SIM))->GetCheck() == 1  )
		yes+="'<nplayers>4P sim<' | ";
	if ( ((CButton*)GetDlgItem(IDC_NPLYR4SIM))->GetCheck() == 0  )
		no+="'<nplayers>4P sim<' | ";

	yes.TrimRight(" |");
	no.TrimRight(" |");
	if (yes.GetLength() != 0)
        criteria +="("+yes+")";
	if (no.GetLength() != 0)
		criteria +=" !("+no+")";

	criteria.Replace(") !(",") & !(");
	
	if (criteria.GetLength() == 0) 
		return false;
	else
		return true;

}


// categories
bool CRomListerDlg::doCategory(CString &criteria)
{
	criteria = "";
	CString yes, no;

	if ( ((CButton*)GetDlgItem(IDC_BALLPADDLE))->GetCheck() == 1  )
		yes+="'ball & paddle' | ";
	if ( ((CButton*)GetDlgItem(IDC_BALLPADDLE))->GetCheck() == 0  )
		no+="'ball & paddle' | ";
	
	if ( ((CButton*)GetDlgItem(IDC_CATBIOS))->GetCheck() == 1  )
		yes+="isbios=yes | ";
	if ( ((CButton*)GetDlgItem(IDC_CATBIOS))->GetCheck() == 0  )
		no+="isbios=yes | ";

	if ( ((CButton*)GetDlgItem(IDC_CATBREAKOUT))->GetCheck() == 1  )
		yes+="breakout | ";
	if ( ((CButton*)GetDlgItem(IDC_CATBREAKOUT))->GetCheck() == 0  )
		no+="breakout | ";

	if ( ((CButton*)GetDlgItem(IDC_CATCASINO))->GetCheck() == 1  )
		yes+="casino | ";
	if ( ((CButton*)GetDlgItem(IDC_CATCASINO))->GetCheck() == 0  )
		no+="casino | ";

	if ( ((CButton*)GetDlgItem(IDC_CATCLIMBING))->GetCheck() == 1  )
		yes+="climbing | ";
	if ( ((CButton*)GetDlgItem(IDC_CATCLIMBING))->GetCheck() == 0  )
		no+="climbing | ";

	if ( ((CButton*)GetDlgItem(IDC_CATDRIVING))->GetCheck() == 1  )
		yes+="driving | ";
	if ( ((CButton*)GetDlgItem(IDC_CATDRIVING))->GetCheck() == 0  )
		no+="driving | ";

	if ( ((CButton*)GetDlgItem(IDC_CATFIGHTER))->GetCheck() == 1  )
		yes+="fighter | ";
	if ( ((CButton*)GetDlgItem(IDC_CATFIGHTER))->GetCheck() == 0  )
		no+="fighter | ";

	if ( ((CButton*)GetDlgItem(IDC_CATMAZE))->GetCheck() == 1  )
		yes+="maze | ";
	if ( ((CButton*)GetDlgItem(IDC_CATMAZE))->GetCheck() == 0  )
		no+="maze | ";

	if ( ((CButton*)GetDlgItem(IDC_CATMINIGAMES))->GetCheck() == 1  )
		yes+="mini-games | ";
	if ( ((CButton*)GetDlgItem(IDC_CATMINIGAMES))->GetCheck() == 0  )
		no+="mini-games | ";

	if ( ((CButton*)GetDlgItem(IDC_CATMATURE))->GetCheck() == 1  )
		yes+="mature | ";
	if ( ((CButton*)GetDlgItem(IDC_CATMATURE))->GetCheck() == 0  )
		no+="mature | ";

	if ( ((CButton*)GetDlgItem(IDC_CATMISC))->GetCheck() == 1  )
		yes+="misc. | ";
	if ( ((CButton*)GetDlgItem(IDC_CATMISC))->GetCheck() == 0  )
		no+="misc. | ";

	if ( ((CButton*)GetDlgItem(IDC_CATMULTIPLAY))->GetCheck() == 1  )
		yes+="multiplay | ";
	if ( ((CButton*)GetDlgItem(IDC_CATMULTIPLAY))->GetCheck() == 0  )
		no+="multiplay | ";

	if ( ((CButton*)GetDlgItem(IDC_CATPINBALL))->GetCheck() == 1  )
		yes+="pinball | ";
	if ( ((CButton*)GetDlgItem(IDC_CATPINBALL))->GetCheck() == 0  )
		no+="pinball | ";

	if ( ((CButton*)GetDlgItem(IDC_CATPLATFORM))->GetCheck() == 1  )
		yes+="platform | ";
	if ( ((CButton*)GetDlgItem(IDC_CATPLATFORM))->GetCheck() == 0  )
		no+="platform | ";

	if ( ((CButton*)GetDlgItem(IDC_CATPUZZLE))->GetCheck() == 1  )
		yes+="puzzle | ";
	if ( ((CButton*)GetDlgItem(IDC_CATPUZZLE))->GetCheck() == 0  )
		no+="puzzle | ";

	if ( ((CButton*)GetDlgItem(IDC_CATQUIZ))->GetCheck() == 1  )
		yes+="quiz | ";
	if ( ((CButton*)GetDlgItem(IDC_CATQUIZ))->GetCheck() == 0  )
		no+="quiz | ";

	if ( ((CButton*)GetDlgItem(IDC_CATRHYTHM))->GetCheck() == 1  )
		yes+="rhythm | ";
	if ( ((CButton*)GetDlgItem(IDC_CATRHYTHM))->GetCheck() == 0  )
		no+="rhythm | ";

	if ( ((CButton*)GetDlgItem(IDC_CATSHOOTER))->GetCheck() == 1  )
		yes+="shooter | ";
	if ( ((CButton*)GetDlgItem(IDC_CATSHOOTER))->GetCheck() == 0  )
		no+="shooter | ";

	if ( ((CButton*)GetDlgItem(IDC_CATSPORTS))->GetCheck() == 1  )
		yes+="sports | ";
	if ( ((CButton*)GetDlgItem(IDC_CATSPORTS))->GetCheck() == 0  )
		no+="sports | ";

	if ( ((CButton*)GetDlgItem(IDC_CATSTABLETOP))->GetCheck() == 1  )
		yes+="tabletop | ";
	if ( ((CButton*)GetDlgItem(IDC_CATSTABLETOP))->GetCheck() == 0  )
		no+="tabletop | ";

//	if ( ((CButton*)GetDlgItem(IDC_CATUNPLAYABLE))->GetCheck() == 1  )
//		yes+="tabletop | ";
//	if ( ((CButton*)GetDlgItem(IDC_CATUNPLAYABLE))->GetCheck() == 0  )
//		no+="tabletop | ";

	if ( ((CButton*)GetDlgItem(IDC_CATWRESTLING))->GetCheck() == 1  )
		yes+="wrestling | ";
	if ( ((CButton*)GetDlgItem(IDC_CATWRESTLING))->GetCheck() == 0  )
		no+="wrestling | ";

	if ( ((CButton*)GetDlgItem(IDC_CATFRUITMACHINE))->GetCheck() == 1  )
		yes+="Fruit_Machines | ";
	if ( ((CButton*)GetDlgItem(IDC_CATFRUITMACHINE))->GetCheck() == 0  )
		no+="Fruit_Machines | ";

	if ( ((CButton*)GetDlgItem(IDC_PINMAME))->GetCheck() == 1  )
		yes+="Electromechanical | ";
	if ( ((CButton*)GetDlgItem(IDC_PINMAME))->GetCheck() == 0  )
		no+="Electromechanical | ";



	yes.TrimRight(" |");
	no.TrimRight(" |");
	if (yes.GetLength() != 0)
        criteria +="("+yes+")";
	if (no.GetLength() != 0)
		criteria +=" !("+no+")";

	criteria.Replace(") !(",") & !(");
	
	if (criteria.GetLength() == 0) 
		return false;
	else
		return true;
}

// popup a rom search dialog.  
// this then locates all the matches or even close matches and displays a list.  user can throw anything from that list over to their working list.
void CRomListerDlg::OnBnClickedRomsearch()
{
	CRl rl;
	extern int g_xmlType;
	extern FILE* m_pinputFile;
	extern CRLSearchItemsThd* gm_pRLSearchItemsThd;
	xmlType xmlData;
	CString romDesc, tmp, tmpDesc;	
	CSearchDlg dlg;
	CGenericOutputDlg dlg2;
	CProgressDlg progDlg;
	float results, results2;
	USES_CONVERSION;
	CSimilar txtCmp;
	int key;
	CString m_output="";

	
	dlg.m_searchCriteria = m_searchCriteria;
	dlg.DoModal();
	if (dlg.m_searchCriteria.GetLength() == 0)
		return;

	if (m_searchCriteria != dlg.m_searchCriteria) // new search? start at the beginning of the file
		m_file.resetFile(m_pinputFile);

	m_searchCriteria = dlg.m_searchCriteria;
	m_searchCriteria.MakeLower();
	char* s = T2A((LPTSTR)(LPCTSTR)m_searchCriteria);	// what we're looking for

	fseek(m_pinputFile, 0, SEEK_SET);	// start at beginning of file


	gm_pRLSearchItemsThd->m_hideSHA1s = m_hideSHA1s;


	progDlg.Init(PROG_MODE_STANDARD, 1000, "Searching...");
	
	try
	{
	
		// let's look for this rom
		while (1)
		{
			key=m_file.getROMDesc(m_pinputFile, romDesc, xmlData.ROMStart[g_xmlType]);
			if (romDesc.GetLength() == 0) break;
			

			rl.getROMDescription(romDesc, tmpDesc);	// human readable rom name	

			char* t = T2A((LPTSTR)(LPCTSTR)tmpDesc.MakeLower());		// new name to compare against
			results = txtCmp.simil( s, t);  // is 1 inside 2?
			results2 = txtCmp.simil( t, s); // is 2 inside 1?
			results = (results+results2);  // the closer we are to 2.0, the better the match
			if ((results >1.2) || (tmpDesc.Find(m_searchCriteria) !=-1) )
				{
					tmp.Format("0x%x",key);		// key = position in file this description was found. 
					tmp +="|";
					m_output+=tmp;
					
					rl.getROMName(romDesc, tmp);	// rom name
					tmp +="|";
					m_output+=tmp;

					rl.getROMDescription(romDesc, tmp);	// human readable rom name
					tmp +="|";
					m_output+=tmp;
				
					rl.gatherItem(romDesc, "<year>", tmp);	// year of release
					if (tmp.GetLength() < 4)
						tmp = "19??";
					tmp +="|";
					m_output+=tmp;

					rl.gatherItem(romDesc, xmlData.manufacturer[g_xmlType], tmp);	// manufacturer
					if ( tmp.GetLength() ==0)
						tmp = "?";
					tmp +="|";
					m_output+=tmp;
				}

		} // while

	// bring up a list dialog
	gm_pRLSearchItemsThd->m_passthruWindowsTitle = "Found %d ROMs";
	gm_pRLSearchItemsThd->m_passthrough = m_output;
	gm_pRLSearchItemsThd->PostThreadMessage(WM_SET_DLG_FOCUS_COMMAND, 0, 0);

	} // try
	// error handling
	catch( CErrorMessage cErr )
	{
		// report the thrown error message
		AfxMessageBox(cErr.m_sMsg, cErr.m_MsgIcon, 0);
		return;
	}	
	progDlg.DestroyWindow();
	
	

	if (m_output.GetLength()==0)
	{
		MessageBox("No matches found!");
		return;
	}

}


// GO!
void CRomListerDlg::OnBnClickedOk()
{
	extern int g_xmlType;
	extern CRLOutPutDlgThd *gm_pRLOutputThd;
	extern	CString prevSearches[MAX_SEARCHES];
	extern  int searchNum;
	
	CString tmp;
	m_cmdLine.GetWindowText(m_cmdLineTxt);
	m_cmdLineTxt.Trim();

	if (m_cmdLineTxt.GetLength() == 0)
	{
		MessageBox("Error! Nothing to search for");
		return;
	}

	CProgressDlg progDlg;
	progDlg.Init(PROG_MODE_TIMER, 1000, "Scanning input file for matches...");


	// new stuff - june 23rd 2008
	// do all initial searches in rom descriptions only, populate a list control and display the matches in a separate output.
	// from the new output window, allow the user to export the list out, delete entries, add things?
	// gather description romname year manufacturer for all matches.

	try
	{
		tmp=m_cmdLineTxt;
		tmp.Remove(' ');
		m_cmdLineTxt.Replace("\"","");		// remove all quotes in case user typed something like numButtons="1"
		expandMacros();	// should check for errors here...
		
		searchNum++;
		if (searchNum > MAX_SEARCHES-1) searchNum=MAX_SEARCHES-1;

		// slide all searches down
		for (int i=MAX_SEARCHES-1; i>0; i--)
			prevSearches[i] = prevSearches[i-1];
		
		prevSearches[0] = m_cmdLineTxt;


		m_RL.m_searchItems = m_cmdLineTxt;
		
		// do a csv lookup of description, romname, year and mfger
		// descriptions only
		m_RL.initialList();  
	
		gm_pRLOutputThd->m_passthrough = m_RL.m_output;
		gm_pRLOutputThd->m_hideSHA1s = m_hideSHA1s;
		gm_pRLOutputThd->PostThreadMessage(WM_SET_DLG_FOCUS_COMMAND, 0, 0);



	} // try
	// error handling
	catch( CErrorMessage cErr )
	{
		// report the thrown error message
		AfxMessageBox(cErr.m_sMsg, cErr.m_MsgIcon, 0);
		return;
	}	
	progDlg.DestroyWindow();
}

// launch the settings dialog
void CRomListerDlg::OnBnClickedSettings()
{
	extern FILE* m_pinputFile;
	extern	int g_hideTags;
	CString tmp;
	CROMListerSettingsDlg dlg;
	dlg.DoModal();
	m_xmlFilename = dlg.m_masterFilePath;
	m_hideSHA1s = dlg.m_hideSHA1s;

	if (m_pinputFile != NULL)
		fclose(m_pinputFile);

	loadInputFile();
}

// anytime we change settings, we need to open and reload the input xml file
void CRomListerDlg::loadInputFile()
{
	extern int g_xmlType; // flag for controls.xml, mame's xml, or merged
	extern FILE* m_pinputFile;
	xmlType xmlData;
	m_xmlHeader="";
	theApp.m_fAllListOpen = false; // make sure a new "list all" is generated now that the file has re-loaded
	// check here if we have no input file yet.
	if (m_xmlFilename.GetLength() ==0)
	{
		AfxMessageBox("Please hit the settings button to select an input file.", MB_ICONERROR, 0);
		((CButton*)GetDlgItem(IDOK))->EnableWindow(0);
		return;
	}

	// open the xml file
	m_pinputFile = fopen(m_xmlFilename,"rb");
	if (m_pinputFile == NULL)
	{
		AfxMessageBox("Open or Read error on input file!?\r\nCheck your settings.", MB_ICONERROR, 0);
		((CButton*)GetDlgItem(IDOK))->EnableWindow(0);
		return;
	}
	else
		((CButton*)GetDlgItem(IDOK))->EnableWindow(1);
	
	// grab the xml file header so we can append it to the output
	m_file.getXMLHeader(m_pinputFile, m_xmlHeader);
	m_file.getXMLType(m_pinputFile);


	if (g_xmlType == -1)
	{
		g_xmlType = MAME;
		AfxMessageBox("Unknown input XML type.  Continue at your own risk!", MB_ICONERROR, 0);
		//((CButton*)GetDlgItem(IDOK))->EnableWindow(0);
		//return;
	}

	// oct-07
	// examine the first description and check for rotate=xx or orientation=vertical 
	
	// default to rev 0.100+ xml type 
	m_verticalTxt = "(rotate=90 | rotate=270)"; 
	m_horizontalTxt = "(rotate=0 | rotate=180)";
	
	m_file.getROMDesc(m_pinputFile, m_ROMDescTxtBox, xmlData.ROMStart[g_xmlType]);	// get one example ROM and examine it to know what xml versioning we're dealing with.
	if ( (m_ROMDescTxtBox.Find("orientation=\"vertical\"") != -1) || (m_ROMDescTxtBox.Find("orientation=\"horizontal\"") !=-1) )
	{
		m_verticalTxt = "orientation=vertical"; 
		m_horizontalTxt = "orientation=horizontal";
	}

	// catver support?
	if (g_xmlType != merged)
	{
		disableCategorySelection(0);
		AfxMessageBox("Note: Because you are not using a merged input file, you will not be able to use category fields for filtering.\r\nYou may also have some incompatibilities outputting lists to certain front ends, due to a lack of information available from your choice of input file.\r\n\r\nYou'll be much happier if you create a merged input file via the settings window.", MB_ICONWARNING, 0);		
	}
	else
		disableCategorySelection(1);


	// nplayers support?
	if ((m_ROMDescTxtBox.Find("<nplayers>") != -1))
		enableNPlayersSelection(1);
	else
		enableNPlayersSelection(0);

	m_file.fIndex = -1; 

	// clear our "all roms list" output flag so we don't get stale data.
	theApp.m_fAllListOpen = false;
}

//void CRomListerDlg::OnCbnSelchangeCategorytype()
//{
//	if (m_categoryType.GetCurSel() ==0) // 0=any, remove the Not option
//		((CButton*)GetDlgItem(IDC_CATEGORY_NOT))->EnableWindow(0);
//	else
//		((CButton*)GetDlgItem(IDC_CATEGORY_NOT))->EnableWindow(1);
//
//	OnBnClickedTweakCmdLine(0);
//}

void CRomListerDlg::OnCbnSelchangeRegion()
{
	if (m_region.GetCurSel() ==0) // 0=any, remove the Not option
		((CButton*)GetDlgItem(IDC_REGION_NOT))->EnableWindow(0);
	else
		((CButton*)GetDlgItem(IDC_REGION_NOT))->EnableWindow(1);

	OnBnClickedTweakCmdLine(0);
}

void CRomListerDlg::OnBnClickedRegionNot()
{
	OnBnClickedTweakCmdLine(0);
}

//input: our -find lookup data, just after the user hit OK.
// here we change out any @USA, @JAPAN, etc macros to their full text equivalent
bool CRomListerDlg::expandMacros()
{
	extern CString g_sRLpath;
	CString macroData;
	CString tmp1, tmp2;
	int pos;

	if (m_cmdLineTxt.Find("@") == -1)	// no macros to expand?  we're ok then.
		return true;


	FILE* inFile;
	inFile = fopen(g_sRLpath+"rlmacros.txt","r");
	
	if (inFile != NULL)
		m_file.loadFile(inFile, macroData);
	else
	{
		CErrorMessage err;											
		err.m_sMsg.Format("Error, cannot find rlmacros.txt file in the folder ROMLister is in.\r\nThis file came with the distribution package, make sure it's unzipped along with romlister.exe");	// oops.
		throw err;	
	}
	
	// close input file
	if (inFile != NULL)
		fclose(inFile);	

	// we've got our data, let's expand the macros out.
	while (macroData.GetLength() > 0)
	{
		pos = macroData.Find("\n");
		if (pos != -1)
			tmp1 = macroData.Left(pos);
		else
			tmp1 = macroData;

		macroData.TrimLeft(tmp1);	// get an entire line
		macroData.Trim();
		if (tmp1.Left(1)==";")
			continue;

		tmp2 = tmp1.Left(tmp1.Find("=")+1);		// isolate the macro data from the keyword
		tmp1.TrimLeft(tmp2);
		tmp2.TrimRight(" =");
		tmp1.Trim();

		m_cmdLineTxt.Replace(tmp2, tmp1);		// replace macro with data
	}
	return true;

}

// bring up a secondary list of every single rom we can find. 
// throw it into a dialog like the working list dialog
void CRomListerDlg::OnBnClickedListallroms()
{
	extern CRLOutPutDlgThd *gm_pRLOutputThd;
	extern CRLAllROMsDlgThd *gm_pRLAllROMsThd;

	CProgressDlg progDlg;
	progDlg.Init(PROG_MODE_STANDARD, 1000, "Generating Full List. This could take a minute or two...");

	try
	{
		// have we done this before?  No need to regenerate the list
		if ( !theApp.m_fAllListOpen )
		{
			m_RL.m_output= "";
			m_RL.m_searchItems = "="; // use something guaranteed to show up in every rom
			m_RL.initialList();
			gm_pRLAllROMsThd->m_passthruWindowsTitle = "Full list of %d ROMs";
			gm_pRLAllROMsThd->m_passthrough = m_RL.m_output;	// the data to populate the list with
			gm_pRLAllROMsThd->m_hideSHA1s = m_hideSHA1s;
			theApp.m_fAllListOpen = true;
		}
		gm_pRLAllROMsThd->PostThreadMessage(WM_SET_DLG_FOCUS_COMMAND, 0, 0);

	} // try
	// error handling
	catch( CErrorMessage cErr )
	{
		// report the thrown error message
		AfxMessageBox(cErr.m_sMsg, cErr.m_MsgIcon, 0);
		return;
	}	
	progDlg.DestroyWindow();
}

void CRomListerDlg::OnBnClickedCatany()
{
	if ( ((CButton*)GetDlgItem(IDC_CATANY))->GetCheck() == 1  )
	{
		for (int i=IDC_BALLPADDLE; i<IDC_CATANY; i++)
		((CButton*)GetDlgItem(i))->SetCheck(2);

		((CButton*)GetDlgItem(IDC_CATBIOS))->SetCheck(0);	// no bios please
	}
	else
	{
		for (int i=IDC_BALLPADDLE; i<IDC_CATANY; i++)
		((CButton*)GetDlgItem(i))->SetCheck(0);
	}

	OnBnClickedTweakCmdLine(0);
}
void CRomListerDlg::disableCategorySelection(bool allowed)
{
		for (int i=IDC_BALLPADDLE; i<=IDC_CATANY; i++)
		((CButton*)GetDlgItem(i))->EnableWindow(allowed);
}
// enable or disable nplayers group if in the xml data
void CRomListerDlg::enableNPlayersSelection(bool allowed)
{					
		for (int i=IDC_NPLYR2ALT; i<=IDC_NPLYR1; i++)
		((CButton*)GetDlgItem(i))->EnableWindow(allowed);
}
/*
void CRomListerDlg::OnBnClickedPrevsearchbtn() // ^
{

	extern	CString prevSearches[MAX_SEARCHES];
	extern  int prevIndex;
	extern  int searchNum;

	if (searchNum == 0) return;	
	
	prevIndex--;
	if (prevIndex == -1)
		prevIndex = MAX_SEARCHES-1;

	for (int i=prevIndex; i>-1; i--)
	{
		if (prevSearches[i].GetLength() > 0)
		{
			m_cmdLine.SetWindowText(prevSearches[i]);
			prevIndex = i;
			break;
		}
	}
}
*/
void CRomListerDlg::OnBnClickedNextsearchbtn()
{
	extern	CString prevSearches[MAX_SEARCHES];

	CSearchHistoryDlg dlg;
	CString searchItem;
	// populate the searches dialog
	for (int i=0; i< MAX_SEARCHES; i++)
		dlg.searches[i] = prevSearches[i];

	dlg.DoModal();

	if (dlg.pickedOne)
		m_cmdLine.SetWindowText(dlg.m_wantThis);

	// get the searches back
	for (int i=0; i< MAX_SEARCHES; i++)
		prevSearches[i] = dlg.searches[i];


/*
	extern  int prevIndex;
	extern  int searchNum;

	if (searchNum == 0) return;

	prevIndex++;
	if (prevIndex == 10)
		prevIndex = 0;
	while (prevSearches[prevIndex].GetLength() == 0)
	{
		prevIndex++;
		if (prevIndex == 10)
			prevIndex = 0;

	}
	m_cmdLine.SetWindowText(prevSearches[prevIndex]);
	*/

}
void CRomListerDlg::loadHistory()
{
	extern	CString prevSearches[MAX_SEARCHES];
	extern CString g_sRLpath;
	FILE* inFile;
	CString historyData;
	CString tmp1;
	int pos;
	int count=0;
	inFile = fopen(g_sRLpath+"searchHistory.txt","r");
	
	if (inFile == NULL)
		return;
    
	m_file.loadFile(inFile, historyData);
		
	// close input file
	if (inFile != NULL)
		fclose(inFile);	

		// we've got our data, let's expand the macros out.
	while (historyData.GetLength() > 0)
	{
		pos = historyData.Find("\n");
		if (pos != -1)
			tmp1 = historyData.Left(pos);// get an entire line
		else
			tmp1 = historyData;

		historyData.Replace(tmp1,"");	
		historyData.Trim();
		tmp1.Trim();
		if (tmp1.Left(1)==";")
			continue;
		
		prevSearches[count] = tmp1;
		count++;
		if (count == MAX_SEARCHES)
			return;
	}


}