#pragma once

// aside from the structure, it looks as if each string needs a length byte 
// and each string ends with 06, 00 instead of just NULL.
//
// data will have to be tweaked before written out to the file to add all the delphi stuff.
//
typedef struct	_malaList {		// 
	CString FName;				// rom name
	CString FRomOf;				// master oder bios name (parent rom)
	CString FCloneOf;			// master rom name 
	CString FSourcefile;		// driver name
	
	CString FDescription;		// game title
    int FYear;					// year
    CString FManufacturer;      // manufacturer
    CString FGenre;				// game genre

    int FInputButtons;			// control panel button count
    int FInputCoins;			// control panel coin count
    CString FInputPlayers;      // player count, nplayers information
	int fAlt;					// if alternating, append "ALT" to this above information
    CString FInputControl;      // kind of game control

    CString FVideoScreen;       // kind of video screen
    CString FVideoOrientation;  // vertical or horizontal
    int FVideoWidth;			// width of the screen
    int FVideoHeight;			// height of the screen

    CString FDriverStatus;
    CString FDriverColor;
    CString FDriverSound;
    CString FDriverEmulation;
    CString FDriverGraphic;

    CString FControls;			// game controls from controls.dat "4-way joystick"
    CString FJoyUp;				// P1_JOYSTICK_UP 
    CString FJoyDown;
    CString FJoyLeft;
    CString FJoyRight;
    CString FButton1;			// "not used" when empty
    CString FButton2;
    CString FButton3;
    CString FButton4;
    CString FButton5;
    CString FButton6;
    CString FButton7;
    CString FButton8;
    CString FDetails;			// <miscDetails> "mahjong games are not compatible..." type notes. not gunna get pulled in.

    CString FRomPath;			// path of romfile
    CString FExtension;			// extension of romfile

    int	FPlayed;
} malaList, *PmalaList;


// list header 
typedef struct	_malaListHeader {		// 
	CString FName;				// list title
    CString FAuthor;
	CString FCreated;			// date and time
	CString FModified;			// date and time
	CString FComment;			// stuff
	bool	FWriteProtected;	// read only

} malaListHeader, *PmalaListHeader;
